package com.freescale.lesson07;

import android.app.Activity;
import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.os.Bundle;

public class lesson07 extends Activity {
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        mGLView = new Lesson07GLSurfaceView(this);
        setContentView(mGLView);
    }

    @Override
    protected void onPause() {
        super.onPause();
        mGLView.onPause();
    }

    @Override
    protected void onResume() {
        super.onResume();
        mGLView.onResume();
    }

    private GLSurfaceView mGLView;

    static {
        System.loadLibrary("lesson07_android");
    	//System.load("/system/app/lesson07.apk/libs/armeabi/liblesson07_android.so"); 
    }
}

class Lesson07GLSurfaceView extends GLSurfaceView {
    public Lesson07GLSurfaceView(Context context) {
        super(context);
        mRenderer = new Lesson07Renderer();
        setRenderer(mRenderer);
    }

    Lesson07Renderer mRenderer;

}

class Lesson07Renderer implements GLSurfaceView.Renderer {
    public void onSurfaceCreated(GL10 gl, EGLConfig config) {
        nativeInit();
    }

    public void onSurfaceChanged(GL10 gl, int w, int h) {

    	nativeResize(w, h);
    }

    public void onDrawFrame(GL10 gl) {
        nativeRender();
    }

    private static native void nativeInit();
    private static native void nativeResize(int w, int h);
    private static native void nativeRender();

}
