//
// C++ Interface: fslGUIScene
//
// Description: 
//
//
// Author: FCSZ <root@ubuntu-desktop>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _FSLGUISCENE_H_
#define _FSLGUISCENE_H_
 
#include <CARD/fslscene.h>
#include <CARD/fslmusictilecard.h>
#include <FSL/fslutil.h>
 
#define NUM_SHADER_CONFIGS 20
#define NUM_CDS 10
class fslGUIScene: public fslScene
{
protected:

	fslMusicTileCard myMusicTileCard_[NUM_CDS];

	fslBool isVisible_;
	GLuint projMatrixLoc_[NUM_SHADER_CONFIGS];
	GLuint shaderProgram_[NUM_SHADER_CONFIGS];
	float currentProjMatrix_[16];
	float currentInvProjMatrix_[16];
	bool isRunning_;	
	
public:
	fslGUIScene( fslScene* parentscene );
	~fslGUIScene();

	fslStatus setAspectRatio( float aspectRatio ); 
	fslStatus setOrientation( fslOrientationType orientation ); 	
	fslStatus transitionOnStage( fslTransitionType transition);
	fslStatus transitionOffStage( fslTransitionType transition);
	fslBool isOnStage();
	fslStatus animResolve( float deltaTime );	
	fslStatus renderScene( fslPhaseType onlyThese);  
	fslStatus handleInputEvent( fslInputEventType event);
	fslStatus initScene(); 
	void receiveCardEvent( unsigned int eventID, void* data);
	bool isRunning(){return isRunning_;}
};

#endif //_FSLGUISCENE_H_

