

/* File: fslexamplecard.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
#ifndef _FSLEXAMPLECARD_H_
#define _FSLEXAMPLECARD_H_
 
#define MAX_INIT_CONFIGS 10
#define MAX_SHADER_LENGTH 2000
#include <GLES2/gl2.h>
#include <EGL/egl.h>
#include <CARD/fslcard.h>

class fslExampleCard: public fslCard
{
protected:
	GLuint modelMatrixLoc_[MAX_INIT_CONFIGS];
	GLuint backgroundTextureHandle_[MAX_INIT_CONFIGS];
	GLuint vertexLoc_;
	GLuint texcoordLoc_;
	
	
public:
	

	fslExampleCard();
	fslExampleCard(void* parentscene);
	~fslExampleCard();

	//Virtual inherited functions
	fslStatus initCard(fslInitStageType init, unsigned int config);
	fslStatus shutdownCard(); 
	fslStatus resumeCard();
	fslStatus drawPlane(float[], float[], GLuint);
	fslStatus animTick(void);
	fslStatus setTickRes(float time);
	fslStatus setTime(float time);
	float getTime();
	fslStatus renderCard(unsigned int phaseID, unsigned int config);
	void getRenderPhases(fslPhaseElementType* phaseArray);
	float getAspectRatio();
	fslStatus handleInputEvent( fslInputEventType event);
	//trackas
};

#endif //_FSLEXAMPLECARD_H_
