
/* File: fslexamplescene.h
 *
 * Copyright  2009 Freescale Semiconductor
 */
 
#ifndef _FSLEXAMPLESCENE_H_
#define _FSLEXAMPLESCENE_H_
 
#include <CARD/fslcard.h>
#include <CARD/fslscene.h>
#include <CARD/fslvideorendercard.h>
#include <CARD/fslvideochaptercard.h>
#include <CARD/fslplaybackcontrolcard.h>
#include <FSL/fslutil.h>
 
#define NUM_SHADER_CONFIGS 2
 
class fslExampleScene: public fslScene
{
protected:
	fslVideoRenderCard myCard_;
	fslVideoChapterCard myChapterCard_;
	fslPlaybackControlCard myPlaybackCard_;
	fslBool isVisible_;
	GLuint projMatrixLoc_[NUM_SHADER_CONFIGS];
	GLuint modelMatrixLoc_[NUM_SHADER_CONFIGS];
	GLuint shaderProgram_[NUM_SHADER_CONFIGS];
	float currentProjMatrix_[16];
	float currentInvProjMatrix_[16];
	float currentInvProjMatrix3_[16];
	int direction;
	bool isRunning_;	
	
public:
	fslExampleScene( fslScene* parentscene );
	~fslExampleScene();

	fslStatus setAspectRatio( float aspectRatio ); 
	fslStatus setOrientation( fslOrientationType orientation ); 	
	fslStatus transitionOnStage( fslTransitionType transition);
	fslStatus transitionOffStage( fslTransitionType transition);
	fslBool isOnStage();
	fslStatus animResolve( float deltaTime );	
	fslStatus renderScene( fslPhaseType onlyThese);  
	fslStatus handleInputEvent( fslInputEventType event);
	fslStatus initScene(); 
	void receiveCardEvent( unsigned int eventID, void* data);
	bool isRunning(){return isRunning_;}
};

#endif //_FSLEXAMPLESCENE_H_

