
/* File: fslfilebrowsercard.h
 *
 * Copyright  2009 Freescale Semiconductor
 */
 
#ifndef _FSLFILEBROWSERCARD_H_
#define _FSLFILEBROWSERCARD_H_
 
#include <CARD/fslcard.h>
#include <FSL/fslutil.h>
 
typedef struct fslFileButton_s {
	fslBool loaded;
	GLuint textureHandle;
	char filename[100];
	fslBool isPressed;
} fslFileButton;

#define MAX_INIT_CONFIGS 10
#define MAX_SHADER_LENGTH 2000
#define FSL_MAX_FILE_BUTTONS 4

class fslFileBrowserCard: public fslCard
{
protected:
	fslFileButton buttonList_[FSL_MAX_FILE_BUTTONS];
	
	int currentButtonDown_;
	float buttonLimits_[5];
	
	GLuint modelMatrixLoc_[MAX_INIT_CONFIGS];
	
	GLuint vertexLoc_;
	GLuint texcoordLoc_;
	
public:
	fslFileBrowserCard();
	fslFileBrowserCard(void* parentscene);
	~fslFileBrowserCard();

	//Virtual inherited functions
	fslStatus initCard(fslInitStageType init, unsigned int config);
	fslStatus shutdownCard(); 
	fslStatus resumeCard();
	fslStatus animTick(void);
	fslStatus setTickRes(float time);
	fslStatus setTime(float time);
	float getTime();
	fslStatus preRenderCard(unsigned int phaseID, unsigned int config); 
	fslStatus renderCard(unsigned int phaseID, unsigned int config);
	void getRenderPhases(fslPhaseElementType* phaseArray);
	float getAspectRatio();
	fslStatus handleInputEvent( fslInputEventType event);

};

#endif //_FSLFILEBROWSERCARD_H_

