
/* File: fslvideobrowserscene.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
 
#ifndef _FSLMUSICCONTAINERSCENE_H_
#define _FSLMUSICCONTAINERSCENE_H_
 
#include <CARD/fslscene.h>
#include <CARD/fslmusictilecard.h>
#include <CARD/fslplaybackcontrolcard.h>
#include <CARD/fslmusicvisualizercard.h>
#include <FSL/fslutil.h>
#include <math.h>
 
#define NUM_SHADER_CONFIGS 6
#define PI 3.14159265
 
class fslMusicContainerScene: public fslScene
{
protected:
	fslMusicTileCard cdCases_[4];
	fslPlaybackControlCard myPlaybackCard_;
	fslMusicVisualizerCard visualizerCard_;
	fslBool isVisible_;
	fslBool showScene_;
	fslBool sceneHidden_;
	unsigned int startTimeOnScreen_;
	unsigned int timeDifference_;
	GLuint projMatrixLoc_[NUM_SHADER_CONFIGS];
	GLuint modelMatrixLoc_[NUM_SHADER_CONFIGS];
	GLuint shaderProgram_[NUM_SHADER_CONFIGS];
	GLuint rotationMatrixLoc_;
	
	GLuint drawOrder_[4];
	float * cdModelViews_[4];
	
	fslBool right;
	fslBool left;
	fslBool goingAway_;	

	float projMatrix_[16];
	float invProjMatrix_[16];
	fslBool projMatrixDirty_;
	
	float modelMatrixcd0_[16];
	fslBool modelMatrixcd0Dirty_;
	float modelMatrixcd1_[16];
	fslBool modelMatrixcd1Dirty_;
	float modelMatrixcd2_[16];
	fslBool modelMatrixcd2Dirty_;
	float modelMatrixcd3_[16];
	fslBool modelMatrixcd3Dirty_;
	

	float rotationM_[16];

	float modelMatrixControl_[16];
	fslBool modelMatrixControlDirty_;
	
	float modelVisualizer_[16];
	fslBool modelVisualizerDirty_;
	
	bool isRunning_;	
	
public:
//	float modelMatrixControl_[16];
	fslMusicContainerScene( fslScene* parentscene );
	~fslMusicContainerScene();

	fslStatus setAspectRatio( float aspectRatio ); 
	fslStatus setOrientation( fslOrientationType orientation ); 	
	fslStatus transitionOnStage( fslTransitionType transition);
	fslStatus transitionOffStage( fslTransitionType transition);
	void tileTransitionOnStage( fslTransitionType transition);
	void tileTransitionOffStage( fslTransitionType transition);
	fslBool isOnStage();
	fslStatus animResolve( float deltaTime );	
	fslStatus renderScene( fslPhaseType onlyThese);  
	fslStatus handleInputEvent( fslInputEventType event);
	fslStatus initScene(); 
	void receiveCardEvent( unsigned int eventID, void* data);
	bool isRunning(){return isRunning_;}
};

#endif //_FSLMUSICCONTAINERSCENE_H_
