
/* File: fslmusictilecard.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
#ifndef _FSLMUSICTILECARD_H_
#define _FSLMUSICTILECARD_H_
 
class fslMusicTileCard: public fslCard
{
protected:
	GLint modelMatrixLoc_[MAX_INIT_CONFIGS];
	char   textureFileName_[FSL_UTIL_MAX_FILE_NAME_LENGTH];
	GLuint isReflected_;
	GLuint  textureHandle_;
	GLuint vertexLoc_;
	GLuint texcoordLoc_;
	GLuint vertexAlphaLoc_;
	GLuint songNumber_;

public:
       fslMusicTileCard();
       fslMusicTileCard(void* parentscene);
       ~fslMusicTileCard();
       fslStatus initCard( fslInitStageType init, unsigned int config); 
       fslStatus setTextureFileName(char* strFilename, unsigned int len);
	fslStatus setSongNumber(GLuint number){songNumber_=number; return FSL_STATUS_SUCCESS;}
	GLuint getSongNumber(){return songNumber_;}
       fslStatus DisableReflection();
       fslStatus EnableReflection();
       fslStatus shutdownCard(); //Releases dynamic resources without destroying card
       fslStatus resumeCard();   //Reallocates resources for card; probably the same as initCard for most cards
       fslStatus handleInputEvent(fslInputEventType);
       fslStatus animTick(void); //adjusts state by the time tick set in resolution
       fslStatus setTickRes(float time);
       fslStatus setTime(float time);
       float     getTime();
       fslStatus renderCard(unsigned int phaseID, unsigned int config); 
       void getRenderPhases(fslPhaseElementType* phaseArray); //assumed fixed size of MAX_PHASE_ARRAY_SIZE
       float getAspectRatio();
};

#endif //_FSLMUSICTILECARD_H_
