
/* File: fslmusicvisualizercard.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
#ifndef _FSLMUSICVISUALIZERCARD_H_
#define _FSLMUSICVISUALIZERCARD_H_

//#define FSL_LOGO_RED 0
//#define FSL_LOGO_YELLOW 1

#include <FSL/fslutil.h>
#include <FSL/fslaudiopipeline.h>
#include <FSL/fslParticleAccelerator.h>
#include <CARD/fslcard.h>
#include <cstdlib>
#include <glib-2.0/glib.h>

 
class fslMusicVisualizerCard: public fslCard
{
protected:
	char   textureFileName_[FSL_UTIL_MAX_FILE_NAME_LENGTH];
	GLuint	vertexLoc_;
	GLuint 	texcoordLoc_;
	GLuint 	colorsLoc_;
	GLuint 	alphaLoc_;
	//GLuint 	modelMatrixLoc_;
	bool 	isAnimated_;
	bool 	morphing_;
	int 	currentEffect;
	fslParticleAccelerator accelerator_;

	enum freescaleLogoColor {
		FSL_LOGO_RED 		= 0,
		FSL_LOGO_YELLOW		= 1,
	};

	enum state {
		BWD 		= 0,
		PAUSE		= 1,
		PLAY		= 2,
		STOP		= 3,
		FWD		= 4,
		DESTROY		= 5,
		REBUILD 	= 6,
		
	};
	
public:

       fslMusicVisualizerCard();
       fslMusicVisualizerCard(void* parentscene);
       ~fslMusicVisualizerCard();
       void resetVisualizer();
       fslStatus initCard( fslInitStageType init, unsigned int config);
       fslStatus shutdownCard(); //Releases dynamic resources without destroying card
       fslStatus resumeCard();   //Reallocates resources for card; probably the same as initCard for most cards
       fslStatus handleInputEvent(fslInputEventType);
       fslStatus animTick(void); //adjusts state by the time tick set in resolution
       fslStatus setTickRes(float time);
       fslStatus setTime(float time);
       float     getTime();
       fslStatus setPipelineState(int state);
       fslStatus renderCard(unsigned int phaseID, unsigned int config); 
       void getRenderPhases(fslPhaseElementType* phaseArray); //assumed fixed size of MAX_PHASE_ARRAY_SIZE
       float getAspectRatio();
};

#endif
