
/* File: fslplaybackcontrolcard.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
#ifndef _FSLPLAYBACKCONTROLCARD_H
#define _FSLPLAYBACKCONTROLCARD_H
 
enum Button_t {REW=0, PAUSE, PLAY, STOP, FFWD, LAST_BUTTON};

struct fslPlaybackControlButton
{
	float xTexCoord;
	float yTexCoord;
	float texWidth;
	float texHeight;
	bool  isPressed;
	
};

class fslPlaybackControlCard: public fslCard
{
protected:
	GLint modelMatrixLoc_[MAX_INIT_CONFIGS];
	GLuint  textureHandle_;
	char  textureFileName_[FSL_UTIL_MAX_FILE_NAME_LENGTH];
	float adderColor_[4]; //Color adder, organized as RGBA R=[0]
	GLuint vertexLoc_;
	GLuint texcoordLoc_;
	GLuint adderColorLoc_;
	GLuint matMVLocalLoc_;
        struct fslPlaybackControlButton buttons_[LAST_BUTTON];
	void initButtons();
public:
       fslPlaybackControlCard();
       fslPlaybackControlCard(void* parentscene);
       ~fslPlaybackControlCard();
       fslStatus initCard( fslInitStageType init, unsigned int config); 
       fslStatus shutdownCard(); //Releases dynamic resources without destroying card
       fslStatus resumeCard();   //Reallocates resources for card; probably the same as initCard for most cards
       fslStatus animTick(void); //adjusts state by the time tick set in resolution
       fslStatus setTickRes(float time);
       fslStatus setTime(float time);
       float     getTime();
       fslStatus preRenderCard(unsigned int phaseID, unsigned int config); 
       fslStatus renderCard(unsigned int phaseID, unsigned int config); 
       void getRenderPhases(fslPhaseElementType* phaseArray); //assumed fixed size of MAX_PHASE_ARRAY_SIZE
       float getAspectRatio();
       fslStatus setAdderColor(float adderColor[4]); // This is only a test mode function
       fslStatus handleInputEvent( fslInputEventType event);
};

#endif //_FSLMUSICTILECARD_H_
