
/* File: fslvideochapterscard.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
#ifndef _FSLVIDEOCHAPTERCARD_H_
#define _FSLVIDEOCHAPTERCARD_H_
 
#define MAX_INIT_CONFIGS 10
#define MAX_SHADER_LENGTH 2000
#define MAX_PREVIEW_FRAMES 240
#include <GLES2/gl2.h>
#include <EGL/egl.h>
#include <CARD/fslcard.h>
#include <CARD/plane.h>
enum Chapter_t {CH0=0, CH1, CH2, CH3, LAST_CHAPTER};
enum Video_t {VIDEO_0=0, VIDEO_1, VIDEO_2, VIDEO_3};
struct fslChapterControlPreview
{

	bool  isPressed;
	
};
class fslVideoChapterCard: public fslCard
{
	protected:
		GLuint modelMatrixLoc_[MAX_INIT_CONFIGS];
		GLuint backgroundTextureHandle_[MAX_INIT_CONFIGS];
		GLuint chapterPreviewTextureHandle_[MAX_PREVIEW_FRAMES];
		GLuint chapter0PreviewTextureHandle;
		GLuint chapter1PreviewTextureHandle;
		GLuint chapter2PreviewTextureHandle;
		GLuint chapter3PreviewTextureHandle;
		GLuint vertexLoc_;
		GLuint texcoordLoc_;
		Plane *filmPlane;
		Plane *chapter0Plane;
		Plane *chapter1Plane;
		Plane *chapter2Plane;
		Plane *chapter3Plane;
		struct fslChapterControlPreview previews_[LAST_CHAPTER];
		int numChapters;
		int framesPerChapter;
		char videoFileName_[200];
	
	
	
	public:
	

		fslVideoChapterCard();
		fslVideoChapterCard(void* parentscene);
		~fslVideoChapterCard();
		float * getModelViewMatrix();
	//Virtual inherited functions
		fslStatus initCard(fslInitStageType init, unsigned int config);
		fslStatus shutdownCard(); 
		fslStatus resumeCard();
		fslStatus drawPlane(float[], float[], GLuint);
		fslStatus animTick(void);
		fslStatus setTickRes(float time);
		fslStatus setTime(float time);
		float getTime();
		fslStatus preRenderCard(unsigned int phaseID, unsigned int config); 
		fslStatus renderCard(unsigned int phaseID, unsigned int config);
		void getRenderPhases(fslPhaseElementType* phaseArray);
		float getAspectRatio();
		fslStatus handleInputEvent( fslInputEventType event);
		fslStatus setVideoFile( char* filename );

};

#endif //_FSLVIDEOCHAPTERSCARD_H_
