
/* File: fslvideochapterscard.h
 *
 * Copyright � 2009 Freescale Semiconductor
 */
#ifndef _FSLVIDEOCHAPTERSCARD_H_
#define _FSLVIDEOCHAPTERSCARD_H_
 
#define MAX_INIT_CONFIGS 10
#define MAX_SHADER_LENGTH 2000
#include <GLES2/gl2.h>
#include <EGL/egl.h>
#include <CARD/fslcard.h>
#include <gst/gst.h>

        
struct thread_data{
        GMainLoop* mainloop;
        void* databuff;
        char fileName[FSL_UTIL_MAX_FILE_NAME_LENGTH];
};



class fslVideoRenderCard: public fslCard
{
protected:
	GLuint modelMatrixLoc_[MAX_INIT_CONFIGS];
	GLuint backgroundTextureHandle_[MAX_INIT_CONFIGS];
	GLuint vertexLoc_;
	GLuint texcoordLoc_;
	int selectedChapter;
	char videoFileName_[FSL_UTIL_MAX_FILE_NAME_LENGTH];	
	thread_data playerThreadData_;
	
	
public:
	

	fslVideoRenderCard();
	fslVideoRenderCard(void* parentscene);
	~fslVideoRenderCard();
	float* getModelViewMatrix();
	//Virtual inherited functions
	fslStatus initCard(fslInitStageType init, unsigned int config);
	fslStatus shutdownCard(); 
	fslStatus resumeCard();
	fslStatus drawPlane(float[], float[], GLuint);
	fslStatus animTick(void);
	fslStatus setTickRes(float time);
	fslStatus setTime(float time);
	float getTime();
	fslStatus seekToChapter(int position);
	fslStatus setChapter(int);
        fslStatus preRenderCard(unsigned int phaseID, unsigned int config); 
	fslStatus renderCard(unsigned int phaseID, unsigned int config);
	void getRenderPhases(fslPhaseElementType* phaseArray);
	float getAspectRatio();
	bool intersects(float, float, float,float,float,float);
	
	fslStatus handleInputEvent( fslInputEventType event);
	fslStatus setVideoFile( char* filename );	

};
#endif //_FSLVIDEORENDERCARD_H_
