#ifndef _FSLPARTICLEACCELERATOR_H_
#define _FSLPARTICLEACCELERATOR_H_

#include <GLES2/gl2.h>
#include <cstdio>
#include <FSL/fslutil.h>
#define MAX_PARTICLES 240     //number of particles


class fslParticleAccelerator
{
protected:
	GLuint  textureHandleParticle1_;
	GLuint  textureHandleParticle2_;
	int 	morphTime_;
	//float particleModelMatrix[MAX_PARTICLES][16];
	float particlePositions[MAX_PARTICLES*24];
	float particleTextCoord[MAX_PARTICLES*12];
	float particleColors[MAX_PARTICLES*18];
	float particleAlpha[MAX_PARTICLES*8];

	//Particle structure ChuChe
	struct particle_s {
		bool active; //is particle active?
		float decay;  //decaying constant determine how fast the particle will turn off
		//float RGBColor[12];    //array of 4 consecutive RGB values for color 	
		//float alpha[4]; //array of corresponging alphas for the particle color
		float x,y,z; //particle position
		float xv,yv,zv; //particle velocity
		float xg,yg,zg; //particle gravity or acceleration
		float rad; //distance from the center
		float angle; //angle for camera rotation
	} particle[MAX_PARTICLES];

	enum effect 
	{
		FOUNTAIN_EFFECT = 0,
		SUPERNOVA_EFFECT = 1,
		FOURFOUNTAIN_EFFECT =2,
		ZEPHIR_EFFECT = 3,
		FOUNTAINSUPERNOVA_EFFECT = 4,		
	};	

public:
	GLuint  textureHandleParticle3_;
	void resetParticles();
	void readline(FILE *, char *);
	fslStatus initParticles(char *);
	void setParticleColor(int );
       	void setParticleColor(int, int);
	void setEffectVelocity(float , int );
	void setMorphSource();
	void setMorphDelta();
	bool updateMorphing(int );
	void updateAccelerator(int );
	void updateEffect(int, int);
	fslStatus initTextures(char *, char *, char *);
	float* getAcceleratorVertex();
	float* getAcceleratorTextCoord();
	float* getAcceleratorColor();
	float* getAcceleratorAlpha();
	//float* getParticleModelMatrix(int);
};
#endif
