
/* File: fslShell.h
 * Author: FCSZ (b20693)
 * Copyright � 2009 Freescale Semiconductor
 */

#ifndef _FSLSHELL_H_
#define _FSLSHELL_H_

#include <GLES2/gl2.h>
#define GL_GLEXT_PROTOTYPES 1
#include <GLES2/gl2ext.h>
#include <GLES2/gl2amdext.h>
#include <EGL/egl.h>
#define EGL_EGLEXT_PROTOTYPES 1
#include <EGL/eglext.h>

#ifdef EGL_USE_X11

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/Xcomposite.h>
#include <X11/extensions/render.h>
#include <X11/extensions/Xrender.h>

#endif

#include <FSL/fslutil.h>
#include <CARD/fslscene.h>

#ifdef EGL_USE_X11
typedef struct XWindow_s {
	Display *display;
	Window window;
	int screen;
	Visual *visual;
	GC gc;
	Colormap colormap;
	int depth;
	int pixelsize;
	XFontStruct *font_info;
	XWindowAttributes attr;
	Picture picture;
	Pixmap pixmap;
} XWindow;
#else
typedef int XWindow;
#endif

class fslShell
{

private:

	EGLDisplay	_egldisplay;
	EGLConfig	_eglconfig;
	EGLSurface	_eglsurface;
	EGLContext	_eglcontext;
public:
	fslShell();
	~fslShell();

	EGLDisplay getDisplay(void) {return _egldisplay;}
	EGLDisplay getConfig(void) {return _eglconfig;}
	EGLDisplay getSurface(void) {return _eglsurface;}
	EGLDisplay getContext(void) {return _eglcontext;}

	void cleanupEGL(XWindow *xwin);
	void cleanupGL();
	bool initEGL(XWindow* xwin);
	bool initGL(fslScene *_myScene );
	void printFramerate(unsigned int &startTime, unsigned int &endTime,
		EGLint width, EGLint height);
	void render(fslScene *_myScene, int width, int height);
	void selectInputType(XWindow* xMainWindow);
	bool handleEvents(XWindow *xMainWindow, XEvent event, fslInputEventType inputEvent,
		EGLint width, EGLint height, fslScene *_myScene);
};

#endif //FSLSHELL_H_

