#ifndef _FSLAUDIOPIPELINE_H_
#define _FSLAUDIOPIPELINE_H_

#include <gst/gst.h>
#include <string.h>
#include <stdbool.h>

#define BIG_GOOM_DURATION 100
#define BIG_GOOM_SPEED_LIMIT 0.1f

#define ACCEL_MULT 0.95f
#define SPEED_MULT 0.99f

struct SoundInfo {
	/* nota : a Goom is just a sound event... */

	int timeSinceLastGoom;   /* >= 0 */
	//float goomPower;         /* power of the last Goom [0..1] */

	//int timeSinceLastBigGoom;   /* >= 0 */

	float volume;     /* [0..1] */
	short samples[2][512];

	/* other "internal" datas for the sound_tester */
	//float goom_limit; /* auto-updated limit of goom_detection */
	//float bigGoomLimit;
	float accelvar;   /* acceleration of the sound - [0..1] */
	float speedvar;   /* speed of the sound - [0..100] */
	float prevspeed;   /* speed of the sound - [0..100] */
	int allTimesMax;
	int totalgoom;    /* number of goom since last reset
			   //* (a reset every 64 cycles) */

	float prov_max;   /* accel max since last reset */

	int cycle;
};

void soundInfo_init();

struct SoundInfo evaluate_sounds(gint16[2][512], struct SoundInfo);

static gboolean bus_call (GstBus *, GstMessage *, gpointer);

static gboolean get_sound_info (GstPad *, GstBuffer *, gpointer);

void buildPipeline(gchar *);

void play();

#endif

