
/* File: 3DMMP_masterscene.h
 *
 * Desc: This is the header for the 'master' scene for the mediaplayer demo
 * Well, let's say this Twinkie represents the normal amount of psychokinetic energy in the New York area
 * 	 
 * Copyright © 2009 Freescale Semiconductor
 */
 
#ifndef _CESDEMO_MASTERSCENE_H_
#define _CESDEMO_MASTERSCENE_H_
 
#include <CARD/fslcard.h>
#include <CARD/fslscene.h>
#include <FSL/fslutil.h>

 
#define CESDEMO_MASTERSCENE_NUM_SHADER_CONFIGS 10

class cesDemoMasterScene: public fslScene
{
protected:
	//Currently active scene
	unsigned int activeScene_;
	
	//Whether the scene is being rendered
	fslBool isVisible_;
	
	//Run state
	bool isRunning_;	
	
	//State for controling animation during scene changes
	fslBool sceneTransition_;
	
public:

	cesDemoMasterScene( fslScene* parentscene );
	~cesDemoMasterScene();

	fslStatus setAspectRatio( float aspectRatio ); 
	fslStatus setOrientation( fslOrientationType orientation ); 	
	//Start rendering the scene
	fslStatus transitionOnStage( fslTransitionType transition);
	//Stop rendering the scene
	fslStatus transitionOffStage( fslTransitionType transition);
	//Query for whether scene is currently rendering
	fslBool isOnStage();
	//Animation tick
	fslStatus animResolve( float deltaTime );	
	fslStatus renderScene( fslPhaseType onlyThese);  
	fslStatus handleInputEvent( fslInputEventType event);
	fslStatus initScene(); 
	// handling child feedback
	void receiveCardEvent( unsigned int eventID, void* data);
	//Query for run status
	bool isRunning(){return isRunning_;}

};

#endif //_CESDEMO_MASTERSCENE_H_

