#include <FSL/fslParticleAccelerator.h>

/*Velocity Values in X and Y*/
float animVelocityX0 = 0.0f;
float animVelocityX1 = 0.0f;
float animVelocityX2 = 0.0f;
float animVelocityY = 0.0f;

/*variables to control fountain direction*/
bool  particleDirection1  = true;
bool  particleDirection2  = true;

/*quadrant variable for supernova effect*/
int quadrant = 1;

/*arrays to contain current particle position and fsl logo position*/
float 	fslLogo_[MAX_PARTICLES*3];
float 	srcObject_[MAX_PARTICLES*3];


float  	delta = 1.0f; //delta for morphing
//float	VertexPositions[16]; //array to contain particle vertex positions
//float 	VertexTexcoord[8]; //array to contain particle texture positions 
//float	ParticleColor[12]; //array to contain the color of the particle


float colors [15][18] =  //array of 15 colors for particles
{
	{1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,
	 1.0f,0.5f,0.5f,1.0f,0.5f,0.5f},
        {1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,
	 1.0f,0.75f,0.5f,1.0f,0.75f,0.5f},
        {1.0f,0.75f,0.75f,1.0f,0.75f,0.75f,1.0f,0.75f,0.75f,1.0f,0.75f,0.75f,
	 1.0f,0.75f,0.75f,1.0f,0.75f,0.75f},
        {1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,
	 1.0f,1.0f,0.5f,1.0f,1.0f,0.5f},
        {0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,
	 0.75f,1.0f,0.5f,0.75f,1.0f,0.5f},
	{0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,
	 0.5f,1.0f,0.5f,0.5f,1.0f,0.5f},
       	{0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,
	 0.5f,1.0f,0.75f,0.5f,1.0f,0.75f},
	{0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,
	 0.5f,1.0f,1.0f,0.5f,1.0f,1.0f},
	{0.5f,0.75f,0.75f,0.5f,0.75f,0.75f,0.5f,0.75f,0.75f,0.5f,0.75f,0.75f,
 	 0.5f,0.75f,0.75f,0.5f,0.75f,0.75f},
	{0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,
	 0.5f,0.75f,1.0f,0.5f,0.75f,1.0f},
	{0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,0.5f,0.5f,1.0f,
	 0.5f,0.5f,1.0f,0.5f,0.5f,1.0f},
	{0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,0.75f,0.5f,1.0f,
	 0.75f,0.5f,1.0f,0.75f,0.5f,1.0f},
	{1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,1.0f,0.5f,1.0f,
	 1.0f,0.5f,1.0f,1.0f,0.5f,1.0f},
	{1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,1.0f,0.5f,0.75f,
	 1.0f,0.5f,0.75f,1.0f,0.5f,0.75f},
	{0.75f,0.5f,0.5f,0.75f,0.5f,0.5f,0.75f,0.5f,0.5f,0.75f,0.5f,0.5f,
	 0.75f,0.5f,0.5f,0.75f,0.5f,0.5f}	
};


/*method to read a line from a File*/
void fslParticleAccelerator::readline(FILE *f, char *string)
{
	do
	{
		fgets(string, 255, f);
	}while((string[0] == '/') || (string[0] == '\n'));
}

fslStatus fslParticleAccelerator::initParticles(char *name){

	int pos;    //number of positions
	FILE *filein; //file containing particle position of the fsl logo
	char line[255]; //char to contain each line read

	filein = fopen(name, "rt"); //open file

	if (filein == NULL) //verify that the file could be opened
	{
		return FSL_STATUS_GENERAL_ERROR;
	}

	readline(filein,line); //read the first line and put it in the file
	sscanf(line, "Vertices: %d\n", &pos); //get number of positions
	
	if (pos == MAX_PARTICLES)
	{
		for (int i = 0; i < MAX_PARTICLES; i++)
		{
			readline(filein,line); //read a line
			particle[i].active    	= true; // set particle as active
			particle[i].decay      	= 0.025f; //set particle decay rate
			/*set particle color as white*/
			particleColors [i*18 +0] = 1.0f;
			particleColors [i*18 +1] = 1.0f;
			particleColors [i*18 +2] = 1.0f;
			particleColors [i*18 +3] = 1.0f;
			particleColors [i*18 +4] = 1.0f;
			particleColors [i*18 +5] = 1.0f;
			particleColors [i*18 +6] = 1.0f;
			particleColors [i*18 +7] = 1.0f;
			particleColors [i*18 +8] = 1.0f;
			particleColors [i*18 +9] = 1.0f;
			particleColors [i*18 +10]= 1.0f;
			particleColors [i*18 +11]= 1.0f;
			particleColors [i*18 +12] = 1.0f;
			particleColors [i*18 +13] = 1.0f;
			particleColors [i*18 +14] = 1.0f;
			particleColors [i*18 +15] = 1.0f;
			particleColors [i*18 +16] = 1.0f;
			particleColors [i*18 +17] = 1.0f;
			
			/*set alpha of partcile*/
			particleAlpha [i*8 +0]    = 1.0f;
			particleAlpha [i*8 +1]    = 1.0f;
			particleAlpha [i*8 +2]    = 1.0f;
			particleAlpha [i*8 +3]    = 1.0f;
			particleAlpha [i*8 +4]    = 1.0f;
			particleAlpha [i*8 +5]    = 1.0f;
			particleAlpha [i*8 +6]    = 1.0f;
			particleAlpha [i*8 +7]    = 1.0f;
			/*get position from the logo and store it in the logo object*/
			sscanf(line, "v %f %f %f\n", &fslLogo_[i*3], &fslLogo_[i*3+1], &fslLogo_[i*3+2]);
			/*set particle position and source object*/
			srcObject_[i*3]= particle[i].x = 0.0f;
			srcObject_[i*3+1] = particle[i].y = 0.0f;
			srcObject_[i*3+2] = particle[i].z = 0.0f;

			particlePositions [i*24 + 0] = particle[i].x+0.075f;
			particlePositions [i*24 +1] = particle[i].y+0.075f;
			particlePositions [i*24 +2] = particle[i].z;
			particlePositions [i*24 +3] = 1.0f;
			particlePositions [i*24 +4] = particle[i].x-0.075f;
			particlePositions [i*24 +5] = particle[i].y+0.075f;
			particlePositions [i*24 +6] = particle[i].z;
			particlePositions [i*24 +7] = 1.0f;
			particlePositions [i*24 +8] = particle[i].x-0.075f;
			particlePositions [i*24 +9] = particle[i].y-0.075f;
			particlePositions [i*24 +10] = particle[i].z;
			particlePositions [i*24 +11] = 1.0f;
			particlePositions [i*24 +12] = particle[i].x+0.075f;
			particlePositions [i*24 +13] = particle[i].y+0.075f;
			particlePositions [i*24 +14] = particle[i].z;
			particlePositions [i*24 +15] = 1.0f;
			particlePositions [i*24 +16] = particle[i].x-0.075f;
			particlePositions [i*24 +17] = particle[i].y-0.075f;
			particlePositions [i*24 +18] = particle[i].z;
			particlePositions [i*24 +19] = 1.0f;
			particlePositions [i*24 +20] = particle[i].x+0.075f;
			particlePositions [i*24 +21] = particle[i].y-0.075f;
			particlePositions [i*24 +22] = particle[i].z;
			particlePositions [i*24 +23] = 1.0f;

			particleTextCoord [i*12 +0] = 1.0f;
			particleTextCoord [i*12 +1] = 1.0f;
			particleTextCoord [i*12 +2] = 0.0f;
			particleTextCoord [i*12 +3] = 1.0f;
			particleTextCoord [i*12 +4] = 0.0f;
			particleTextCoord [i*12 +5] = 0.0f;
			particleTextCoord [i*12 +6] = 1.0f;
			particleTextCoord [i*12 +7] = 1.0f;
			particleTextCoord [i*12 +8] = 0.0f;
			particleTextCoord [i*12 +9] = 0.0f;
			particleTextCoord [i*12 +10] = 1.0f;
			particleTextCoord [i*12 +11] = 0.0f;	

			/*set particle velocity in x,y,z*/
			particle[i].xv	      	= 0.0f;
			particle[i].yv	      	= 0.0f;
			particle[i].zv 	      	= 0.0f;
			/*set acceleration in x,y,z*/
			particle[i].xg        	= 0.0f;
			particle[i].yg        	= 0.0f;
			particle[i].zg        	= 0.0f;
			/*set radius and angle for particle -ange and radius can be use for other effect not used in this demo-*/
			particle[i].rad       	= (float(i)/MAX_PARTICLES)*5.0f;
			particle[i].angle     	= 0.0f;
		}	
	}
	//if positions and number of particles not equal close the file return error
	else 
	{
		fclose(filein); 
		return FSL_STATUS_GENERAL_ERROR;
	}
	fclose(filein); //close the file
	return FSL_STATUS_SUCCESS;
}

//method to place all particles at the origin
void fslParticleAccelerator::resetParticles()
{
		for (int i = 0; i < MAX_PARTICLES; i++)
		{
			srcObject_[i*3]= particle[i].x = 0.0f;
			srcObject_[i*3+1] = particle[i].y = 0.0f;
			srcObject_[i*3+2] = particle[i].z = 0.0f;
			particlePositions [i*24 + 0] = particle[i].x+0.075f;
			particlePositions [i*24 +1] = particle[i].y+0.075f;
			particlePositions [i*24 +2] = particle[i].z;
			particlePositions [i*24 +3] = 1.0f;
			particlePositions [i*24 +4] = particle[i].x-0.075f;
			particlePositions [i*24 +5] = particle[i].y+0.075f;
			particlePositions [i*24 +6] = particle[i].z;
			particlePositions [i*24 +7] = 1.0f;
			particlePositions [i*24 +8] = particle[i].x-0.075f;
			particlePositions [i*24 +9] = particle[i].y-0.075f;
			particlePositions [i*24 +10] = particle[i].z;
			particlePositions [i*24 +11] = 1.0f;
			particlePositions [i*24 +12] = particle[i].x+0.075f;
			particlePositions [i*24 +13] = particle[i].y+0.075f;
			particlePositions [i*24 +14] = particle[i].z;
			particlePositions [i*24 +15] = 1.0f;
			particlePositions [i*24 +16] = particle[i].x-0.075f;
			particlePositions [i*24 +17] = particle[i].y-0.075f;
			particlePositions [i*24 +18] = particle[i].z;
			particlePositions [i*24 +19] = 1.0f;
			particlePositions [i*24 +20] = particle[i].x+0.075f;
			particlePositions [i*24 +21] = particle[i].y-0.075f;
			particlePositions [i*24 +22] = particle[i].z;
			particlePositions [i*24 +23] = 1.0f;
		}
}

//change particle color in position n .01 towards the color specified in logoColor
void fslParticleAccelerator::setParticleColor(int n, int logoColor)
{

	if (logoColor == 0)
	{
		for (int j = 0; j<18; j+=3)
		{
			if(particleColors[n*18+0+j] < 1.0f)
				particleColors[n*18+0+j] += 0.01f;
			if(particleColors[n*18+1+j] > 0.0f)
				particleColors[n*18+1+j] -= 0.01f;
			if(particleColors[n*18+2+j] > 0.0f)
				particleColors[n*18+2+j] -= 0.01f;
		}
	} 
	else if (logoColor == 1)
	{
		for (int j = 0; j<18; j+=3)
		{
			if(particleColors[n*18+0+j] < 1.0f)
				particleColors[n*18+0+j] += 0.01f;
			if(particleColors[n*18+1+j] < 1.0f)
				particleColors[n*18+1+j] += 0.01f;
			if(particleColors[n*18+2+j] > 0.0f)
				particleColors[n*18+2+j] -= 0.01f;
		}
	}
}	

//set particle color in positon n to a random color in the colors array
void fslParticleAccelerator::setParticleColor(int n)
{
	int random = rand()%15;
	for (int j = 0; j<18; j++)
	{
		particleColors[n*18+j] = colors[random][j];
	}
}

//method to set particle velocity according to a effect
void fslParticleAccelerator::setEffectVelocity(float speed, int effect)
{
	if (effect == FOUNTAIN_EFFECT) //if fountain efect
	{
		if (particleDirection1)
		{
			if (speed<0.02f) //make sure speed is not too high
				//change x velocity in a exponential a fashion
				animVelocityX0 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity is 200 or bigger change direction
			if (animVelocityX0 >= 200.0f)			
				particleDirection1 = false;	
		}
		else
		{ 	
			
			if (speed<0.02f) //make sure speed is not too high
				animVelocityX0 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity is -200 or smaller change direction
			if (animVelocityX0 <= -200.0f)
				particleDirection1 = true;
		}
	//if Zephir or supernova effect
	}else if ((effect == SUPERNOVA_EFFECT) || (effect == ZEPHIR_EFFECT))
	{
		//if we want to send particles to the first quadrant
		if (quadrant == 1)
		{
			if (speed<=0.02f) //make sure speed is not too high
				//change x velocity in a exponential a fashion
				animVelocityX0 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity bigger than -200 and speed is not too high
			if((animVelocityY > -200.0f) && (speed<0.02f))
			{
				//change y velocity in a exponential a fashion
				animVelocityY -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is -200 or smaller go to the second quadrant
			if (animVelocityX0 <= -200.0f)
				quadrant = 2;	
		}
		//if we want to send particles to the second quadrant
		else if (quadrant == 2)
		{
			if (speed<0.02f) //make sure speed is not too high
				//change y velocity in a exponential a fashion
				animVelocityY += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if y velocity is 200 or bigger go to the quadrant 3
			if (animVelocityY >= 200.0f)
				quadrant = 3;
		}
		//if we want to send particles to quadrant 3
		else if (quadrant == 3)
		{
			if (speed<0.02f)//make sure speed is not too high
				//change x velocity in a exponential a fashion
				animVelocityX0 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity is 200 or bigger go to the quadrant 4
			if (animVelocityX0 >= 200.0f)
				quadrant = 4;
		}
		//if we want to send particles to quadrant 4
		else if (quadrant == 4)
		{
			if (speed<0.02f)//make sure speed is not too high
				//change y velocity in a exponential a fashion
				animVelocityY -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if y velocity is 200 or bigger go to the quadrant 1
			if (animVelocityY <= -200.0f)
				quadrant = 1;
		}else
			quadrant = 1;
	}else if (effect == FOURFOUNTAIN_EFFECT)
	{
		//get velocity for particles on one side of the screen
		if (particleDirection1)
		{
			if (speed<0.02f)//make sure speed is not too high
			{	
				//change x velocity in a exponential a fashion
				animVelocityX0 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is 400 or bigger change direction
			if (animVelocityX0 >= 400.0f)
				particleDirection1 = false;
		}
		else
		{ 	
			if (speed<0.02f)//make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX0 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is 0 or less change direction
			if (animVelocityX0 <= 0.0f)
				particleDirection1 = true;
		}
		//get velocity for particles on oposite side of the screen
		if (particleDirection2)
		{
			if (speed<0.02f)//make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX1 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is 0 or bigger change direction
			if (animVelocityX1 >= 0.0f)
				particleDirection2 = false;
		}
		else
		{ 	
			if (speed<0.02f)//make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX1 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is -400 or less change direction
			if (animVelocityX1 <= -400.0f)
				particleDirection2 = true;
		}
	}else if (effect == FOUNTAINSUPERNOVA_EFFECT)
	{
		//get velocity for particles on one side of the screen
		if (particleDirection1)
		{
			if (speed<0.02f) //make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX0 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is 400 or bigger change direction
			if (animVelocityX0 >= 400.0f)
				particleDirection1 = false;
		}
		else
		{ 	
			if (speed<0.02f) //make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX0 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is 0 or less change direction
			if (animVelocityX0 <= 0.0f)
				particleDirection1 = true;
		}
		//get velocity for particles on oposite side of the screen
		if (particleDirection2)
		{
			if (speed<0.02f) //make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX1 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is 0 or bigger change direction
			if (animVelocityX1 >= 0.0f)
				particleDirection2 = false;
		}
		else
		{ 	
			if (speed<0.02f) //make sure speed is not too high
			{
				//change x velocity in a exponential a fashion
				animVelocityX1 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is -400 or less change direction
			if (animVelocityX1 <= -400.0f)
				particleDirection2 = true;
		}
		//if we want to send particles to the first quadrant
		if (quadrant == 1)
		{
			if (speed<0.02f)//make sure speed is not too high
				//change x velocity in a exponential a fashion
				animVelocityX2 -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity bigger than -200 and speed is not too high
			if((animVelocityY > -200.0f) && (speed<0.02f))
			{
				//change y velocity in a exponential a fashion
				animVelocityY -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			}
			//if x velocity is -200 or smaller go to the second quadrant
			if (animVelocityX2 <= -200.0f)
				quadrant = 2;	
		}
		//if we want to send particles to the second quadrant
		else if (quadrant == 2)
		{
			if (speed<0.02f)//make sure speed is not too high
				//change y velocity in a exponential a fashion
				animVelocityY += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if y velocity is 200 or bigger go to the quadrant 3
			if (animVelocityY >= 200.0f)
				quadrant = 3;
		}
		//if we want to send particles to quadrant 3
		else if (quadrant == 3)
		{
			if (speed<0.02f)//make sure speed is not too high
				//change x velocity in a exponential a fashion
				animVelocityX2 += ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity is 200 or bigger go to the quadrant 4
			if (animVelocityX2 >= 200.0f)
				quadrant = 4;
		}
		//if we want to send particles to quadrant 4
		else if (quadrant == 4)
		{
			if (speed<0.02f)//make sure speed is not too high
				//change y velocity in a exponential a fashion
				animVelocityY -= ((speed * 400.00f)*(speed * 400.00f)*(speed * 400.00f));
			//if x velocity is 200 or bigger go to the quadrant 1
			if (animVelocityY <= -200.0f)
				quadrant = 1;
		}else
			quadrant = 1;	
	}
}

//set current position of the particles as source object for morphing
void fslParticleAccelerator::setMorphSource()
{
	for (int j = 0; j < MAX_PARTICLES; j++)
	{
		srcObject_[j*3] = particle[j].x;
		srcObject_[j*3+1] = particle[j].y;
		srcObject_[j*3+2] = particle[j].z;
	}
	morphTime_ = fslGetTickCount() + 3000;
}

//set morph delta 
void fslParticleAccelerator::setMorphDelta()
{
	delta = ((float)(morphTime_ - fslGetTickCount()))/3000.0f;
}

//update particle in position in space according to morphing
bool fslParticleAccelerator::updateMorphing(int n)
{
	if(fslGetTickCount() < morphTime_)
	{
		particle[n].x = ((fslLogo_[n*3] * (1.0f-delta)) + 	(srcObject_[n*3]*delta));
		particle[n].y = ((fslLogo_[n*3+1] * (1.0f-delta)) + (srcObject_[n*3+1]*delta));
		particle[n].z = ((fslLogo_[n*3+2] * (1.0f-delta)) + (srcObject_[n*3+2]*delta));
		particlePositions [n*24 + 0] = particle[n].x+0.075f;
		particlePositions [n*24 +1] = particle[n].y+0.075f;
		particlePositions [n*24 +2] = particle[n].z;
		particlePositions [n*24 +3] = 1.0f;
		particlePositions [n*24 +4] = particle[n].x-0.075f;
		particlePositions [n*24 +5] = particle[n].y+0.075f;
		particlePositions [n*24 +6] = particle[n].z;
		particlePositions [n*24 +7] = 1.0f;
		particlePositions [n*24 +8] = particle[n].x-0.075f;
		particlePositions [n*24 +9] = particle[n].y-0.075f;
		particlePositions [n*24 +10] = particle[n].z;
		particlePositions [n*24 +11] = 1.0f;
		particlePositions [n*24 +12] = particle[n].x+0.075f;
		particlePositions [n*24 +13] = particle[n].y+0.075f;
		particlePositions [n*24 +14] = particle[n].z;
		particlePositions [n*24 +15] = 1.0f;
		particlePositions [n*24 +16] = particle[n].x-0.075f;
		particlePositions [n*24 +17] = particle[n].y-0.075f;
		particlePositions [n*24 +18] = particle[n].z;
		particlePositions [n*24 +19] = 1.0f;
		particlePositions [n*24 +20] = particle[n].x+0.075f;
		particlePositions [n*24 +21] = particle[n].y-0.075f;
		particlePositions [n*24 +22] = particle[n].z;
		particlePositions [n*24 +23] = 1.0f;
		return true;
	}
	else
	{
		return false;
	}
}

//update particle in position n 
void fslParticleAccelerator::updateAccelerator(int n)
{
	particleAlpha [n*4 +0]-=	particle[n].decay;
	particleAlpha [n*4 +1]-=	particle[n].decay;
	particleAlpha [n*4 +2]-=	particle[n].decay;
	particleAlpha [n*4 +3]-=	particle[n].decay;
	particle[n].x+=particle[n].xv/2000.0f;
	particle[n].y+=particle[n].yv/2000.0f;
	particle[n].z+=particle[n].zv/2000.0f;	
	particle[n].xv+=particle[n].xg;
	particle[n].yv+=particle[n].yg;
	particle[n].zv+=particle[n].zg;
	particlePositions [n*24 + 0] = particle[n].x+0.075f;
	particlePositions [n*24 +1] = particle[n].y+0.075f;
	particlePositions [n*24 +2] = particle[n].z;
	particlePositions [n*24 +3] = 1.0f;
	particlePositions [n*24 +4] = particle[n].x-0.075f;
	particlePositions [n*24 +5] = particle[n].y+0.075f;
	particlePositions [n*24 +6] = particle[n].z;
	particlePositions [n*24 +7] = 1.0f;
	particlePositions [n*24 +8] = particle[n].x-0.075f;
	particlePositions [n*24 +9] = particle[n].y-0.075f;
	particlePositions [n*24 +10] = particle[n].z;
	particlePositions [n*24 +11] = 1.0f;
	particlePositions [n*24 +12] = particle[n].x+0.075f;
	particlePositions [n*24 +13] = particle[n].y+0.075f;
	particlePositions [n*24 +14] = particle[n].z;
	particlePositions [n*24 +15] = 1.0f;
	particlePositions [n*24 +16] = particle[n].x-0.075f;
	particlePositions [n*24 +17] = particle[n].y-0.075f;
	particlePositions [n*24 +18] = particle[n].z;
	particlePositions [n*24 +19] = 1.0f;
	particlePositions [n*24 +20] = particle[n].x+0.075f;
	particlePositions [n*24 +21] = particle[n].y-0.075f;
	particlePositions [n*24 +22] = particle[n].z;
	particlePositions [n*24 +23] = 1.0f;
}

//method to update particle in position n according to the given effect
void fslParticleAccelerator::updateEffect(int n, int effect)
{
	if(effect == FOUNTAIN_EFFECT) //if fountain effect
	{
		//if particle has faded
		if((particleAlpha [n*4 +0] <= 0.0f) || (particleAlpha [n*4 +1] <= 0.0f) || (particleAlpha [n*4 +2] <= 0.0f) || (particleAlpha [n*4 +3] <= 0.0f))
		{
			//set the decaying/fading rate of the particle
			particle[n].decay      	= float(rand()%100)/1000.0f+0.003f;
			//set a random color for the particle
			setParticleColor(n);
			//set particle as fully visible
			particleAlpha [n*4 +0]    = 1.0f;
			particleAlpha [n*4 +1]    = 1.0f;
			particleAlpha [n*4 +2]    = 1.0f;
			particleAlpha [n*4 +3]    = 1.0f;
			//set particle position in the corresponding emisor
			particle[n].x	      	= -0.75f;
			particle[n].y	      	= -4.5f;
			particle[n].z 		= 0.0f;
			//set particle velocity
			particle[n].xv	      	= animVelocityX0+float ((rand()%40)-32.0f);
			particle[n].yv	      	= 425.0f + float ((rand()%60)-30.0f);
			particle[n].zv 	      	= float (rand()%200 - rand()%200);
			//set particle gravity
			particle[n].yg        	= -8.0f;	
		}
	}else if(effect == SUPERNOVA_EFFECT)
	{
		//if particle has faded
		if((particleAlpha [n*4 +0] <= 0.0f) || (particleAlpha [n*4 +1] <= 0.0f) || (particleAlpha [n*4 +2] <= 0.0f) || (particleAlpha [n*4 +3] <= 0.0f))
		{
			//set the decaying/fading rate of the particle
			particle[n].decay      	= float(rand()%100)/1000.0f+0.003f;
			//set a random color for the particle
			setParticleColor(n);
			//set particle as fully visible
			particleAlpha [n*4 +0]    = 1.0f;
			particleAlpha [n*4 +1]    = 1.0f;
			particleAlpha [n*4 +2]    = 1.0f;
			particleAlpha [n*4 +3]    = 1.0f;
			//set particle position in the corresponding emisor
			particle[n].x	      	= -0.75f;
			particle[n].y	      	= -1.5f;
			particle[n].z 		= 0.0f;
			//throw particle upward
			if((n%2)==0)
			{
				particle[n].yv	      	= animVelocityY+float ((rand()%40)-32.0f);
				particle[n].xv	      	= animVelocityX0+float ((rand()%40)-32.0f);
			}
			//throw particle downward
			else if((n%2)==1)
			{
				particle[n].yv	      	= float ((rand()%40)-32.0f)-animVelocityY;
				particle[n].xv	      	= float ((rand()%40)-32.0f)-animVelocityX0;
			}
			//set particle velocity in z
			particle[n].zv 	      	= float (rand()%200 - rand()%200);
			//set particle gravity
			particle[n].yg        	= -8.0f;		
		}
	}else if(effect == FOURFOUNTAIN_EFFECT)
	{
		//if particle has faded
		if((particleAlpha [n*4 +0] <= 0.0f) || (particleAlpha [n*4 +1] <= 0.0f) || (particleAlpha [n*4 +2] <= 0.0f) || (particleAlpha [n*4 +3] <= 0.0f))
		{
			//set the decaying/fading rate of the particle
			particle[n].decay      	= float(rand()%100)/1000.0f+0.003f;
			//set a random color for the particle
			setParticleColor(n);
			//set particle as fully visible
			particleAlpha [n*4 +0]    = 1.0f;
			particleAlpha [n*4 +1]    = 1.0f;
			particleAlpha [n*4 +2]    = 1.0f;
			particleAlpha [n*4 +3]    = 1.0f;
			//set particle z position at 0
			particle[n].z 		= 0.0f;
			//set particle velocity in z
			particle[n].zv 	      	= float (rand()%200 - rand()%200);
			//set particle gravity
			particle[n].yg        	= -8.0f;
			//set position an velocity for upleft fountain
			if (n%4==0)
			{
				particle[n].x	      = -5.75f;
				particle[n].y	      =  2.5f;
				particle[n].xv	      = animVelocityX0+float ((rand()%40)-32.0f);
				particle[n].yv	      = -425.0f - float ((rand()%60)-30.0f);
			}
			//set position an velocity for upright fountain
			if (n%4==1)
			{
				particle[n].x	        =  4.25f;
				particle[n].y	        =  2.5f;
				particle[n].xv	        = animVelocityX1+float ((rand()%40)-32.0f);
				particle[n].yv	      = -425.0f - float ((rand()%60)-30.0f);
			}
			//set position an velocity for downleft fountain
			if (n%4==2)
			{
				particle[n].x	      =  -5.75f;
				particle[n].y	      =  -4.5f;
				particle[n].xv	      = animVelocityX0+float ((rand()%40)-32.0f);
				particle[n].yv	      = 425.0f + float ((rand()%60)-30.0f);
			}
			//set position an velocity for downright fountain
			if (n%4==3)
			{
				particle[n].x	      =   4.25f;
				particle[n].y	      =  -4.5f;
				particle[n].xv	      = animVelocityX1+float ((rand()%40)-32.0f);
				particle[n].yv	      = 425.0f + float ((rand()%60)-30.0f);
			}
		}
	}else if(effect == ZEPHIR_EFFECT)
	{
		//if particle has faded
		if((particleAlpha [n*4 +0] <= 0.0f) || (particleAlpha [n*4 +1] <= 0.0f) || (particleAlpha [n*4 +2] <= 0.0f) || (particleAlpha [n*4 +3] <= 0.0f))
		{
			//set the decaying/fading rate of the particle
			particle[n].decay      	= float(rand()%100)/1000.0f+0.003f;
			//set a random color for the particle     	= 0.01f;
			setParticleColor(n);
			//set particle as fully visible
			particleAlpha [n*4 +0]    = 1.0f;
			particleAlpha [n*4 +1]    = 1.0f;
			particleAlpha [n*4 +2]    = 1.0f;
			particleAlpha [n*4 +3]    = 1.0f;
			//set particle position in the corresponding emisor
			particle[n].x	      	= -0.75f;
			particle[n].y	      	= -1.5f;
			particle[n].z 		= 0.0f;
			//throw particle in upright direction
			if((n%4)==0)
			{
				particle[n].yv	      	= animVelocityY+float ((rand()%40)-32.0f);
				particle[n].xv	      	= animVelocityX0+float ((rand()%40)-32.0f);
			}
			//throw particle in upleft direction
			else if((n%4)==1)
			{
				particle[n].yv	      	= float ((rand()%40)-32.0f)+animVelocityY;
				particle[n].xv	      	= float ((rand()%40)-32.0f)-animVelocityX0;
			}
			//throw particle in downleft direction
			else if((n%4)==2)
			{
				particle[n].yv	      	= float ((rand()%40)-32.0f)-animVelocityY;
				particle[n].xv	      	= float ((rand()%40)-32.0f)-animVelocityX0;
			}
			//throw particle in downright direction
			else if((n%4)==3)
			{
				particle[n].yv	      	= float ((rand()%40)-32.0f)-animVelocityY;
				particle[n].xv	      	= float ((rand()%40)-32.0f)+animVelocityX0;
			}		
		}
	}else if(FOUNTAINSUPERNOVA_EFFECT)
	{
		//if particle has faded
		if((particleAlpha [n*4 +0] <= 0.0f) || (particleAlpha [n*4 +1] <= 0.0f) || (particleAlpha [n*4 +2] <= 0.0f) || (particleAlpha [n*4 +3] <= 0.0f))
		{
			//set the decaying/fading rate of the particle
			particle[n].decay      	= float(rand()%100)/1000.0f+0.003f;
			//set a random color for the particle
			setParticleColor(n);
			//set particle as fully visible
			particleAlpha [n*4 +0]    = 1.0f;
			particleAlpha [n*4 +1]    = 1.0f;
			particleAlpha [n*4 +2]    = 1.0f;
			particleAlpha [n*4 +3]    = 1.0f;
			//set particle z position at 0
			particle[n].z 		= 0.0f;
			//set position an velocity for upleft fountain
			if (n%6==0)
			{
				particle[n].x	      = -5.75f;
				particle[n].y	      =  2.5f;
				particle[n].xv	      = animVelocityX0+float ((rand()%40)-32.0f);
				particle[n].yv	      = -425.0f - float ((rand()%60)-30.0f);
			}
			//set position an velocity for upright fountain
			if (n%6==1)
			{
				particle[n].x	        =  4.25f;
				particle[n].y	        =  2.5f;
				particle[n].xv	        = animVelocityX1+float ((rand()%40)-32.0f);
				particle[n].yv	      = -425.0f - float ((rand()%60)-30.0f);
			}
			//set position an velocity for downleft fountain
			if (n%6==2)
			{
				particle[n].x	      =  -5.75f;
				particle[n].y	      =  -4.5f;
				particle[n].xv	      = animVelocityX0+float ((rand()%40)-32.0f);
				particle[n].yv	      = 425.0f + float ((rand()%60)-30.0f);
			}
			//set position an velocity for downright fountain
			if (n%6==3)
			{
				particle[n].x	      =   4.25f;
				particle[n].y	      =  -4.5f;
				particle[n].xv	      = animVelocityX1+float ((rand()%40)-32.0f);
				particle[n].yv	      = 425.0f + float ((rand()%60)-30.0f);
			}
			//throw particle upward
			if (n%6==4)
			{
				particle[n].x	      	= -0.75f;
				particle[n].y	      	= -1.5f;
				particle[n].yv	      	= animVelocityY+float ((rand()%40)-32.0f);
				particle[n].xv	      	= animVelocityX2+float ((rand()%40)-32.0f);
			}
			//throw particle downward
			if (n%6==5)
			{
				particle[n].x	      	= -0.75f;
				particle[n].y	      	= -1.5f;
				particle[n].yv	      	= float ((rand()%40)-32.0f)-animVelocityY;
				particle[n].xv	      	= float ((rand()%40)-32.0f)-animVelocityX2;
			}
			//set particle velocity in z
			particle[n].zv 	      	= float (rand()%200 - rand()%200);
			//set particle gravity
			particle[n].yg        	= -8.0f;
		}
	}
}

//init particle textures
fslStatus fslParticleAccelerator::initTextures(char *particle1, char *particle2, char *particle3)
{
	if(!fslInit2DCTESTextureGL( particle1 , &textureHandleParticle1_))
        {
		return FSL_STATUS_GENERAL_ERROR;
	}
	if(!fslInit2DCTESTextureGL( particle2 , &textureHandleParticle2_))
	{
		return FSL_STATUS_GENERAL_ERROR;
        }
	if(!fslInit2DCTESTextureGL( particle3 , &textureHandleParticle3_))
	{
		return FSL_STATUS_GENERAL_ERROR;
	}
	return FSL_STATUS_SUCCESS;
}

//get vertex positions for particle position n
float * fslParticleAccelerator::getAcceleratorVertex()
{
	/*VertexPositions[0] = particle[n].x+0.075f;
	VertexPositions[1] = particle[n].y+0.075f;
	VertexPositions[2] = particle[n].z;
	VertexPositions[3] = 1.0f;
	VertexPositions[4] = particle[n].x-0.075f;
	VertexPositions[5] = particle[n].y+0.075f;
	VertexPositions[6] = particle[n].z;
	VertexPositions[7] = 1.0f;
	VertexPositions[8] = particle[n].x+0.075f;
	VertexPositions[9] = particle[n].y-0.075f;
	VertexPositions[10] = particle[n].z;
	VertexPositions[11] = 1.0f;
	VertexPositions[12] = particle[n].x-0.075f;
	VertexPositions[13] = particle[n].y-0.075f;
	VertexPositions[14] = particle[n].z;
	VertexPositions[15] = 1.0f;*/

	return particlePositions;
}

//get texture coordinates
float * fslParticleAccelerator::getAcceleratorTextCoord()
{

	return particleTextCoord;
}
										
//get particle color for particle in position n
float* fslParticleAccelerator::getAcceleratorColor()
{
	/*for (int i = 0; i<12; i++)
		ParticleColor[i] = particle[n].RGBColor[i];*/
	return particleColors;
}

//get alpha value for particle in position n
float* fslParticleAccelerator::getAcceleratorAlpha()
{
	return particleAlpha;
}
