// C++ Implementation: 3DGUI
// Author: FCSZ <b20593>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution

#include <CARD/fslmusiccontainerscene.h>
#include <FSL/fslShell.h>

//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------

	fslShell *_myShell;
	fslMusicContainerScene *_myScene;

//--------------------------------------------------------------------------------------
// Macro constants
//--------------------------------------------------------------------------------------

#define PRINT_FRAMERATE 1

//--------------------------------------------------------------------------------------
// Name: main
// Desc: main
//--------------------------------------------------------------------------------------
int main (void)
{
	_myShell = new fslShell();
	_myScene = new fslMusicContainerScene(0);

	XWindow	xMainWindow;
#ifdef EGL_USE_X11
	XEvent 	event;
#endif	
	EGLint 	width = 0, height = 0;
	float	animStartTime = 0, animEndTime = 0;
	fslInputEventType inputEvent;
	
#ifdef PRINT_FRAMERATE	
	unsigned int	startTime = 0, endTime = 0;
#endif		

	printf("Freescale 3D Demo\n");
	printf("++Starting Initialization\n");
	printf("++This is fslMusicContainerScene testapp\n");
	
	//Set up error handler here
	
	if( !_myShell->initEGL( &xMainWindow ) ) { return -1; }
	if( !_myShell->initGL(_myScene) ) { return -1; }
	
	printf("--Finished Initializing (%d x %d).  Now Rendering. \n",width, height);

	animStartTime = ((float) fslGetTickCount() / 1000.f);

	_myShell->selectInputType(&xMainWindow);
	int safe = 0;
	while (_myScene->isRunning())
	{
		eglQuerySurface(_myShell->getDisplay(), _myShell->getSurface(), EGL_WIDTH, &width);
		eglQuerySurface(_myShell->getDisplay(), _myShell->getSurface(), EGL_HEIGHT, &height);

		//Check for new events here (update)
		_myShell->handleEvents(&xMainWindow, event, inputEvent, width, height, _myScene);

		animEndTime = ( (float) fslGetTickCount() / 1000.0f);
		_myScene->animResolve(animEndTime - animStartTime);
		animStartTime = animEndTime;
		//draw
		_myShell->render(_myScene, width, height);

// 		g_currentFrame++;

		_myShell->printFramerate(startTime, endTime, width, height);	
		//if (safe++ == 900) break;


	}
	_myShell->cleanupGL( );
	_myShell->cleanupEGL( &xMainWindow );

	delete _myShell;
	delete _myScene;

	_myShell = 0;
	_myScene = 0;
	return 0;
}
