// C++ Implementation: 3DGUI
// Author: FCSZ <b20593>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution

#include "testscene_fslmusicvisualizercard.h"
#include <FSL/fslShell.h>

//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------

unsigned int	g_currentFrame = 0;

//--------------------------------------------------------------------------------------
// Macro constants
//--------------------------------------------------------------------------------------

#define PRINT_FRAMERATE 1

//--------------------------------------------------------------------------------------
// Name: main
// Desc: main
//--------------------------------------------------------------------------------------
int main (void)
{
	fslShell _myShell;
	fslMusicVisualizerScene _myScene(0);

	XWindow	xMainWindow;
#ifdef EGL_USE_X11
	XEvent 	event;
#endif	
	EGLint 	width = 0, height = 0;
	float	animStartTime = 0.0f, animEndTime = 0.0f;
	fslInputEventType inputEvent;
	
#ifdef PRINT_FRAMERATE	
	unsigned int	startTime = 0, endTime = 0;
#endif		

	printf("Freescale 3D Demo\n");
	printf("++Starting Initialization\n");
	
	//Set up error handler here
	
	if( !_myShell.initEGL( &xMainWindow ) ) { return -1; }
	if( !_myShell.initGL(&_myScene) ) { return -1; }
	
	printf("--Finished Initializing (%d x %d).  Now Rendering. \n",width, height);

	animStartTime = ((float) fslGetTickCount() / 1000.0f);

	_myShell.selectInputType(&xMainWindow);
	
	while (_myScene.isRunning())
	{
		eglQuerySurface(_myShell.getDisplay(), _myShell.getSurface(), EGL_WIDTH, &width);
		eglQuerySurface(_myShell.getDisplay(), _myShell.getSurface(), EGL_HEIGHT, &height);

		//Check for new events here
		_myShell.handleEvents(&xMainWindow, event, inputEvent, width, height, &_myScene);

		animEndTime = ( (float) fslGetTickCount() / 1000.0f);
		_myScene.animResolve(animEndTime - animStartTime);
		animStartTime = animEndTime;
		
		_myShell.render(&_myScene, width, height);

		g_currentFrame++;

		_myShell.printFramerate(startTime, endTime, width, height);	

	}
	_myShell.cleanupGL( );
	_myShell.cleanupEGL( &xMainWindow );

	return 0;
}