//
// C++ Interface: fslVisualizerScene
//
// Description: 
//
//
// Author: FCSZ <root@ubuntu-desktop>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _FSLVISUALIZERSCENE_H_
#define _FSLVISUALIZERSCENE_H_
 
#include <FSL/fslutil.h>
#include <CARD/fslscene.h>
#include <CARD/fslmusicvisualizercard.h>

//#define NUM_SHADER_CONFIGS 20
//#define NUM_CDS 1
class fslMusicVisualizerScene: public fslScene
{
public:
	fslMusicVisualizerScene( fslScene* parentscene );
	~fslMusicVisualizerScene();

	fslStatus setAspectRatio( float aspectRatio ); 
	fslStatus setOrientation( fslOrientationType orientation ); 	
	fslStatus transitionOnStage( fslTransitionType transition);
	fslStatus transitionOffStage( fslTransitionType transition);
	fslBool isOnStage();
	fslStatus animResolve( float deltaTime );	
	fslStatus renderScene( fslPhaseType onlyThese);  
	fslStatus handleInputEvent( fslInputEventType event);
	fslStatus initScene(); 
	void receiveCardEvent( unsigned int eventID, void* data);
	bool isRunning(){return isRunning_;}

protected:
	fslMusicVisualizerCard myMusicVisualizerCard;
	fslBool isVisible_;
	GLuint projMatrixLoc;
	GLuint shaderProgram;
	GLint modelMatrixLoc_;
	float currentProjMatrix_[16];
	float currentInvProjMatrix_[16];
	float visualizerModViewMatrix_[16];
	bool isRunning_;

};

#endif //_FSLVISUALIZERSCENE_H_
