#include <GLES2/gl2.h>
#include <EGL/egl.h>
#include <CARD/fslvideochaptercard.h>

#include <FSL/fslutil.h>
#include <gst/gst.h>
#include <stdbool.h>
#include <stdio.h>
#include <pthread.h>
#include <CARD/fslscene.h>


static const char* g_strEnd =
		"}													\n";

static const char* g_strVSProgramA = 

		"													\n"
		"attribute vec4 g_vVertex;							\n"
		"attribute vec4 g_vTexcoord;						\n"
		"varying   vec4 g_vVSTexcoord;						\n"
		"													\n";

static const char* g_strVSProgramB = 
		"void main()										\n"
		"{													\n"	

    //"    vec4 vPositionES = g_matModelView * g_vVertex; \n"

		"    vec4 cardPosition = g_vVertex;   \n"


		"    g_vVSTexcoord = g_vTexcoord;					\n";
		

//What vars should scene control?
//g_strVSProgram = g_strVSProgramA + SceneA + g_strVSProgramB + SceneB + g_strEnd;
//SceneB =   "    gl_Position  = cardPosition;		\n"

static const char* g_strFSProgramA = 
		"#ifdef GL_FRAGMENT_PRECISION_HIGH									\n"
		"   precision highp float;											\n"
		"#else																\n"
		"   precision mediump float;										\n"
		"#endif																\n"
		"																	\n"
		"uniform   sampler2D g_sImageTexture;								\n"
		"varying   vec4      g_vVSTexcoord;									\n"
		"																	\n";

static const char* g_strFSProgramB = 
		"void main()														\n"
		"{																	\n"
		"    vec4 cardColor;	\n"		
		"    cardColor.r = 0.0;	\n"		
		"    cardColor.g = 0.5;	\n"		
		"    cardColor.b = 0.3;	\n"
		"    cardColor.a = 1.0;	\n"		
		"    cardColor = texture2D(g_sImageTexture, g_vVSTexcoord.xy);	\n";
 
    

//g_strFSProgram = g_strFSProgramA + SceneA + g_strFSProgramB + SceneB + g_strEnd;
//SceneB =   "    gl_FragColor = cardColor;	\n";








//initializacion
int currentChapter = 0;
int currentVideo = 0;
int currentFrame = 0;
int chapterVideoFrameStart = 0;
const int CHAPTER_0 = 0;
const int CHAPTER_1 = 1;
const int CHAPTER_2 = 2;
const int CHAPTER_3 = 3;



fslVideoChapterCard::fslVideoChapterCard( )
{
	parentScene_ = NULL;
	vertexLoc_ = 0;
	texcoordLoc_ = 1;
	return;
}

fslVideoChapterCard::fslVideoChapterCard( void* parentscene )
{
	parentScene_ = parentscene;
	vertexLoc_ = 0;
	texcoordLoc_ = 1;
	return;
}

fslVideoChapterCard::~fslVideoChapterCard()
{
		
			
	return;
}

//This should probably be made to work with 'n' shaders
fslStatus fslVideoChapterCard::initCard( fslInitStageType init, unsigned int config) 
{
	
	
	static GLuint hVertexShader;
	static GLuint hFragmentShader;
	//bgPlane = new Plane();
	numChapters = 4;
	framesPerChapter = 15;
	
	
	filmPlane = new Plane();
	//creates the left plane, width and height
	filmPlane->createPlane(0.27,0.9);
	//create chapter planes
	chapter0Plane = new Plane();
	chapter0Plane->createPlane(.2,.18);
	chapter0Plane->flipUVCoords();
	chapter0Plane->translateY(.3);//adjusts translation
	//plane for the second chapter preview
	chapter1Plane = new Plane();
	chapter1Plane->createPlane(.2,.18);
	chapter1Plane->flipUVCoords();
	chapter1Plane->translateY(.1);
	//plane for the third chapter preview
	chapter2Plane = new Plane();
	chapter2Plane->createPlane(.2,.18);
	chapter2Plane->flipUVCoords();
	chapter2Plane->translateY(-.10);
	//plane for the fourth chapter preview
	chapter3Plane = new Plane();
	chapter3Plane->createPlane(.2,.18);
	chapter3Plane->flipUVCoords();
	chapter3Plane->translateY(-.30);
	
	
	
	switch(init)
	{
		case FSL_INIT_COMPILE:
			// Create the shader program needed to render the texture
		{
			GLint nCompileResult;
			char vs[MAX_SHADER_LENGTH];
			char ps[MAX_SHADER_LENGTH];
			const char* pvs = (char*)(vs); // This is kind of silly and I'm not sure why this is being required in C++ and not C
			const char* pps = (char*)(ps); //  may also be solved with &(const_cast<char*>(vs))

				//vs = new char[MAX_SHADER_LENGTH];
				//ps = new char[MAX_SHADER_LENGTH];

			printf("Starting Initialization \n");

				//This would probably be better handled with string objects
			sprintf(ps, "%s %s %s %s %s", g_strFSProgramA, pixelPreString_, g_strFSProgramB, pixelPostString_, g_strEnd);
			sprintf(vs, "%s %s %s %s %s", g_strVSProgramA, vertexPreString_, g_strVSProgramB, vertexPostString_, g_strEnd);
				
				//Could probably add more code to make this less intensive on subsequent inits 
			printf("About to load texture! \n");
			char filename[50];
	      		//this will load all the preview files, dpends on how many chapters, and how many files per chapter
			int numPreviewFrame = 0;
			for(int k =0; k<4;k++){
				
				for(int i=0; i<numChapters;i++){
			
					
					for(int j =0; j<framesPerChapter;j++){
						sprintf(filename,"media/previews/video%i/Ch%i_%i.bmp",k,i,j);
						printf("loading %s \n",filename);
				
						if(!fslInit2DBMPTextureGL(filename,&chapterPreviewTextureHandle_[numPreviewFrame]))
							return FSL_STATUS_GENERAL_ERROR;     
						else
							numPreviewFrame++;
				
					}
			
					chapter0PreviewTextureHandle=chapterPreviewTextureHandle_[0];
					chapter1PreviewTextureHandle=chapterPreviewTextureHandle_[15];
					chapter2PreviewTextureHandle=chapterPreviewTextureHandle_[29];
					chapter3PreviewTextureHandle=chapterPreviewTextureHandle_[45];
			
			
				}
			}
			printf("Loaded %i frames \n",numPreviewFrame);
	      
	 
/*
		
*/			//loads other relevant textures
			if(!fslInit2DCTESTextureGL( "media/textures/frame256x256.CTES", &backgroundTextureHandle_[0] ))
				return FSL_STATUS_GENERAL_ERROR;
		
			printf("Vertex Shader = \n %s \n", vs);
			printf("Pixel Shader = \n %s \n", ps);

					// Compile the shaders
			printf("Compiling chaptercard Shaders... \n");
			hVertexShader = glCreateShader( GL_VERTEX_SHADER );
			glShaderSource( hVertexShader, 1, &pvs, NULL );
			glCompileShader( hVertexShader );

			hFragmentShader = glCreateShader( GL_FRAGMENT_SHADER );
			glShaderSource( hFragmentShader, 1, &pps, NULL );
			glCompileShader( hFragmentShader );

				// Check for compile success
			nCompileResult = 0;
			glGetShaderiv(hFragmentShader, GL_COMPILE_STATUS, &nCompileResult);
				
			if (!nCompileResult)
			{
				char Log[1024];
				GLint nLength;
				printf("Error compiling shader video chaptercard shader! \n");
				glGetShaderInfoLog(hFragmentShader, 1024, &nLength, Log);
				return FSL_STATUS_GENERAL_ERROR;
			}

				// Attach the individual shaders to the common shader program
			shaderProgram_[config] = glCreateProgram();
			glAttachShader( shaderProgram_[config], hVertexShader );
			glAttachShader( shaderProgram_[config], hFragmentShader );

				// Init attributes BEFORE linking
			glBindAttribLocation(shaderProgram_[config], vertexLoc_,   "g_vVertex");
			glBindAttribLocation(shaderProgram_[config], texcoordLoc_, "g_vTexcoord");
				
			numShaderAttributes_ = 2; //The scene can use attributes higher than this

		}
 		
		break;
		case FSL_INIT_LINK:
		{
			GLint nLinkResult;
				
				// Link the vertex shader and fragment shader together
			printf("Linking videoCHapter Shaders... \n");
			glLinkProgram( shaderProgram_[config] );

				// Check for link success
			nLinkResult = 0;
			glGetProgramiv(shaderProgram_[config], GL_LINK_STATUS, &nLinkResult);
			if (!nLinkResult)
			{
				char Log[1024];
				GLint nLength;
				printf("Error linking videoChapter shader! \n");
				glGetProgramInfoLog(shaderProgram_[config], 1024, &nLength, Log);
				return FSL_STATUS_GENERAL_ERROR;
			}

				//projMatrixLoc = glGetUniformLocation( g_hshaderProgram_, "g_matProj" );
			//modelMatrixLoc_[config] = glGetUniformLocation( shaderProgram_[config], "g_matModelView" );

			glDeleteShader( hVertexShader );
			glDeleteShader( hFragmentShader );
		
				

				


				
		}			
		break;
		default:
			return FSL_STATUS_BAD_PARAMETER;
	}
	
	
	return FSL_STATUS_SUCCESS;
}

fslStatus fslVideoChapterCard::shutdownCard() //Releases dynamic resources without destroying card
{
	//TBD
	return FSL_STATUS_SUCCESS;
}

fslStatus fslVideoChapterCard::resumeCard()   //Reallocates resources for card; probably the same as initCard for most cards
{
	//TBD
	printf("RESUMING CARD....! \n");
	return FSL_STATUS_SUCCESS;
}
int frameSkip = 0;
bool hasToChangeFrame = FALSE;

fslStatus fslVideoChapterCard::animTick(void) //adjusts state by the time tick set in resolution
{
	//probably you want to skips frames from the previews if your frame rate is too high
	//you can try repeating the last frame 2 or 3 times
	if(frameSkip <3){
		frameSkip++;
		hasToChangeFrame = FALSE;
	}
		
	else{
		hasToChangeFrame = TRUE;
		frameSkip = 0;
	}
	
	float speed = .001f;

	if(filmPlane){
		
		filmPlane->vertexTexCoords[1]+=speed;
		filmPlane->vertexTexCoords[3]+=speed;
		filmPlane->vertexTexCoords[5]+=speed;
		filmPlane->vertexTexCoords[7]+=speed;
		filmPlane->vertexTexCoords[9]+=speed;
		filmPlane->vertexTexCoords[11]+=speed;
	}
	if(hasToChangeFrame){
		
		
		switch(currentChapter){
			//this will change a frame by pointing to the next texture(or preview file) in the array, when the end of the chapter is reached (every 15 frames) it switches to the next chapter frame
		
			case CHAPTER_0:
				chapter0PreviewTextureHandle =	chapterPreviewTextureHandle_[chapterVideoFrameStart+currentFrame];
				if(currentFrame <currentChapter*framesPerChapter+framesPerChapter)
					currentFrame++;
				else
					currentChapter++;
				break;
			
			case CHAPTER_1:
				chapter1PreviewTextureHandle = chapterPreviewTextureHandle_[chapterVideoFrameStart+(currentFrame++)];
				if(currentFrame <currentChapter*framesPerChapter+framesPerChapter)
					currentFrame++;
				else
					currentChapter++;
				break;	
			
			case CHAPTER_2:
				chapter2PreviewTextureHandle = chapterPreviewTextureHandle_[chapterVideoFrameStart+(currentFrame++)];
				if(currentFrame <currentChapter*framesPerChapter+framesPerChapter)
					currentFrame++;
				else
					currentChapter++;
				break;
			
			case CHAPTER_3:
				chapter3PreviewTextureHandle = chapterPreviewTextureHandle_[chapterVideoFrameStart+(currentFrame++)];
				if(currentFrame <currentChapter*framesPerChapter+framesPerChapter)
					currentFrame++;
				else{
					currentChapter = CHAPTER_0;
					currentFrame = 0;	
				}
				
				break;
		}
		
	}
	
	

	
	return FSL_STATUS_SUCCESS;
}

fslStatus fslVideoChapterCard::setTickRes(float time)
{
	//This card currently has no animation
	tickTime_ = time;
	
	return FSL_STATUS_SUCCESS;
}

fslStatus fslVideoChapterCard::setTime(float time)
{
	//This card currently has no animation
	currentTime_ = time;
	
	return FSL_STATUS_SUCCESS;
}

float fslVideoChapterCard::getTime()
{
	return currentTime_;
}
fslStatus fslVideoChapterCard::preRenderCard(unsigned int phaseID, unsigned int config)
{
	switch(phaseID)
	{
		case 1:
                        // Set the shader program and the texture
			glUseProgram( shaderProgram_[config] );
			break;
		default:
			return FSL_STATUS_BAD_PARAMETER;
	}

	return FSL_STATUS_SUCCESS;

}

fslStatus fslVideoChapterCard::renderCard( unsigned int phaseID, unsigned int config )  
{
	//Broken into phases so master render function doesn't get things out of order (alpha, etc.)
	//PhaseID are set by the card in the getRenderPhases
	//Scenes call getRenderPhases to get stages needed by card
	//Scenes then call renderCard with the IDs they got from getRenderPhases grouped with other
	//  cards by the type
	glDisable(GL_DEPTH_TEST);
	int textureID = 0;
	
	switch(phaseID)
	{
		case 1:
		{
	
				//chapter frame
			glUseProgram( shaderProgram_[config] );
			
			
		 	//draws the left plane with its texture, this is the side bar
			drawPlane(filmPlane->vertex,filmPlane->vertexTexCoords,backgroundTextureHandle_[0]);
			
			//draws each plane to display the previews
			drawPlane(chapter0Plane->vertex,chapter0Plane->vertexTexCoords,chapter0PreviewTextureHandle);
			
			drawPlane(chapter1Plane->vertex,chapter1Plane->vertexTexCoords,chapter1PreviewTextureHandle);
			
			drawPlane(chapter2Plane->vertex,chapter2Plane->vertexTexCoords,chapter2PreviewTextureHandle);
			
			drawPlane(chapter3Plane->vertex,chapter3Plane->vertexTexCoords,chapter3PreviewTextureHandle);

		}

		break;

		default:
			return FSL_STATUS_BAD_PARAMETER;
	}
	
	return FSL_STATUS_SUCCESS;
}


void fslVideoChapterCard::getRenderPhases(fslPhaseElementType* phaseArray) 
{
	if(phaseArray == NULL)
		return;
		
	//phaseArray is assumed fixed size of MAX_PHASE_ARRAY_SIZE
	//This card only has one stage
	
	//Scene runs through array until FSL_PHASE_UNSPECIFIED is reached
	phaseArray[0].type = FSL_PHASE_RENDER_WRITEONLY;
	phaseArray[0].phaseID = 1;
	phaseArray[1].type = FSL_PHASE_UNSPECIFIED;
	phaseArray[1].phaseID = 0;

	return;
}

float fslVideoChapterCard::getAspectRatio()
{
	//This is only a hard-coded suggested value as the scene can really use whatever it wants
	return 4.0f/3.0f; 
}

//These events are ONLY card relevent;  All coords are in 0-1, 0-1, card space (lower left origin)
fslStatus fslVideoChapterCard::handleInputEvent( fslInputEventType event)
{
	//No inputs for this card
	if(event.input == FSL_INPUT_POINTERDOWN) 
	{
		printf("chap %d,%d \n",event.signalA,event.signalB);
	
		int index = 0;
		//float x = ((float)event.signalA-1901)/6190;
		//float y = ((float)event.signalB-2695)/4606;
		float x = ((float)event.signalA)/10000;
		float y = ((float)event.signalB)/10000;
		
		 //float y = (float)event.signalB;
		//previews_[index].isPressed = true;
		printf("cardSpace %f , %f \n",x,y);
		//if((x>0&&x<0.15)&&(y<1)){
		if((x>0&&x<1.0)&&(y<1)){
			if (parentScene_)
			{
				
				if(y<=.90& y>=.73)
				{
					index = 0;
				}
				if(y<=.69& y>=.51)
				{
					index = 1;
				}
				if(y<=.48& y>=.29)
				{
					index = 2;
				}
				if(y<=.27& y>=.08)
				{
					index = 3;
				}
				((fslScene*)parentScene_)->receiveCardEvent(index + baseEventID_, NULL);
				previews_[index].isPressed = true;
				printf("click in chapter %i \n",index);
			} 
			
		}
		
	}
	else if(event.input == FSL_INPUT_POINTERUP) 
	{
		for (int i = CH0; i < LAST_CHAPTER; i++) 
		{
			previews_[i].isPressed = false;
		}
	} else if (event.input == FSL_INPUT_CLOSEWINDOW)
	{
		if (parentScene_)
		{
			((fslScene*)parentScene_)->receiveCardEvent(event.input, NULL);
		} 
		shutdownCard();
	}
	
	return FSL_STATUS_SUCCESS;
}

//this method recieves a vertex array, a texture array(UVCoords) and a texture handler
//then draws the current plane
fslStatus fslVideoChapterCard::drawPlane( float VertexPos[] , float TexCoords[], GLuint texture)
{
			
	//binds the texture from the handle			
	glBindTexture( GL_TEXTURE_2D, texture );

	glVertexAttribPointer( vertexLoc_, 4, GL_FLOAT, 0, 0, VertexPos );
	glEnableVertexAttribArray( vertexLoc_ );

	glVertexAttribPointer( texcoordLoc_, 2, GL_FLOAT, 0, 0, TexCoords);
	glEnableVertexAttribArray( texcoordLoc_ );

	//printf("Drawing...\n");
	//draws the two triangles of the plane
	glDrawArrays( GL_TRIANGLES, 0, 6 );
	glDisableVertexAttribArray( vertexLoc_ );
	glDisableVertexAttribArray( texcoordLoc_ );
	return FSL_STATUS_SUCCESS;
}


//given a filename chooses the appropiate file, this is hardcode, should be generic
fslStatus fslVideoChapterCard::setVideoFile( char* filename )
{
	
	printf("Setting Video Chapter Select to %s(%i) \n", filename,strlen(filename));
	
	sprintf(videoFileName_, "%s", filename);
	
	chapterVideoFrameStart = 0;
	//checks if the video is the correct one
	if(strcmp(filename,"media/video/movie4.mp4")==0)
	{
		printf("displaying frames for video %s \n",filename);
		chapterVideoFrameStart = 60;
		currentFrame = chapterVideoFrameStart;
	
	
		
	}
		
	if( strcmp(filename,"media/video/movie3.mp4")==0)
	{
		printf("displaying frames for video %s \n",filename);
		chapterVideoFrameStart = 0;
		currentFrame =chapterVideoFrameStart;
		
		
	}
	
	if(strcmp(filename,"media/video/movie2.mp4")==0)
	{
		printf("displaying frames for video %s \n",filename);
		chapterVideoFrameStart = 120;
		currentFrame = chapterVideoFrameStart;	
		
	}
	
	if(strcmp(filename,"media/video/movie1.mp4")==0)
	{
		printf("displaying frames for video %s \n",filename);
		chapterVideoFrameStart = 180;
		currentFrame = chapterVideoFrameStart;	
		
	}
	
	//only 4 videos available for now
	chapter0PreviewTextureHandle=chapterPreviewTextureHandle_[chapterVideoFrameStart+0];
	chapter1PreviewTextureHandle=chapterPreviewTextureHandle_[chapterVideoFrameStart+15];
	chapter2PreviewTextureHandle=chapterPreviewTextureHandle_[chapterVideoFrameStart+29];
	chapter3PreviewTextureHandle=chapterPreviewTextureHandle_[chapterVideoFrameStart+45];
		   
	//May want to fail on bad filename
	return FSL_STATUS_SUCCESS;	
}








