
#include "CARD/plane.h"
//this is an utility class for creating planes, a plane
//consists of two triangles

//empty constructor, creates an empty triangle
Plane::Plane(void ){
	
	posX=0.0f;
	posY =0.0f;
	width=0.0f;
	height=0.0f;
	
	//initialization of UV coords
	for(int i=0; i<24;i++){
		vertex[i]=0.0f;
	}
	
	for(int j=0; j<12;j++){
		vertexTexCoords[j]=0.0f;
	}
	
} 

//creates a plane of a given width and height
void Plane:: createPlane(float w,float h){
	width = w;
	height = h;
	
	//this plane will be created in the center of the universe (0,0,0) later the plane can be translated
	posX = 0;
	posY = 0;
	
	//this will create the actual plane with the corresponding positions of each vertex
	vertex[0]=  posX-width/2; //lower left X
	vertex[1]=  posY-height/2; //lower left y
	vertex[2]= -0.0f; vertex[3]= 1.0f;
	
	vertex[4]= posX+width/2;//lower right x
	vertex[5]= posY-height/2;//lower right y
	vertex[6]= -0.0f; vertex[7]= 1.0f;

	vertex[8]= posX-width/2;//upper left
	vertex[9]= posY+height/2;//upper left
	vertex[10]= -0.0f; vertex[11]= 1.0f;
	
	vertex[12]= posX-width/2; //upper left
	vertex[13]= posY+height/2;//upper left
	vertex[14]= -0.0f; vertex[15]= 1.0f;

	vertex[16]= posX+width/2; //lower right
	vertex[17]= posY-height/2; //lower right
	vertex[18]= -0.0f; vertex[19]= 1.0f;

	vertex[20]= posX+width/2; //upper right
	vertex[21]= posY+height/2; //upper right
	vertex[22]= -0.0f; vertex[23]= 1.0f;	
	genPlaneUVCoords();

}
//creates a plane in a given position
void Plane:: createPlane(float px, float py, float w, float h){


	posX = px;
	posY = py*-2;
	width = w*2;
	height = h*2;

	posX = posX-width/2;//screen width 
	posY = posY+1;//screen height
	
  

 // float width_offset = 1.0f;
	//float height_offset = 1.0f;
	
	vertex[0]=  posX; //lower left X
	vertex[1]=  posY-height; //lower left y
	vertex[2]= 0.0f; vertex[3]= 1.0f;
	
	vertex[4]= posX+width;//lower right x
	vertex[5]= posY-height;//lower right y
	vertex[6]= 0.0f; vertex[7]= 1.0f;

	vertex[8]= posX;//upper left
	vertex[9]= posY;//upper left
	vertex[10]= 0.0f; vertex[11]= 1.0f;
	
	vertex[12]= posX; //upper left
	vertex[13]= posY;//upper left
	vertex[14]= 0.0f; vertex[15]= 1.0f;

	vertex[16]= posX+width; //lower right
	vertex[17]= posY-height; //lower right
	vertex[18]= 0.0f; vertex[19]= 1.0f;

	vertex[20]= posX+width; //upper right
	vertex[21]= posY; //upper right
	vertex[22]= 0.0f; vertex[23]= 1.0f;	
	genPlaneUVCoords();
}

//in case you need to flip UV coordinates (both of them)
void Plane::flipUVCoords(){
	
	vertexTexCoords[0]=0.0; vertexTexCoords[1]=0.0f; //lower left
	vertexTexCoords[2]=1.0; vertexTexCoords[3]=	0.0f;//lower right
	vertexTexCoords[4]=0.0; vertexTexCoords[5]=	1.0;//upper left
	vertexTexCoords[6]=0.0; vertexTexCoords[7]=	1.0;//upper left
	vertexTexCoords[8]=1.0; vertexTexCoords[9]=	0.0f;//lower right
	vertexTexCoords[10]=1.0;vertexTexCoords[11]= 1.0;//upper right	
}
//this method flips only the U coords
void Plane::flipUCoords(){
	
	
	vertexTexCoords[0]=1.0; vertexTexCoords[1]=1.0f; //lower left
	vertexTexCoords[2]=0.0; vertexTexCoords[3]=	1.0f;//lower right
	vertexTexCoords[4]=1.0; vertexTexCoords[5]=	0.0;//upper left
	vertexTexCoords[6]=1.0; vertexTexCoords[7]=	0.0;//upper left
	vertexTexCoords[8]=0.0; vertexTexCoords[9]=	1.0f;//lower right
	vertexTexCoords[10]=0.0;vertexTexCoords[11]= 0.0;//upper right
}
//this method flips only the V coords
void Plane::genPlaneUVCoords(){
	
	vertexTexCoords[0]=0.0; vertexTexCoords[1]=1.0f; //lower left
	vertexTexCoords[2]=1.0; vertexTexCoords[3]=	1.0f;//lower right
	vertexTexCoords[4]=0.0; vertexTexCoords[5]=	0.0;//upper left
	vertexTexCoords[6]=0.0; vertexTexCoords[7]=	0.0;//upper left
	vertexTexCoords[8]=1.0; vertexTexCoords[9]=	1.0f;//lower right
	vertexTexCoords[10]=1.0;vertexTexCoords[11]= 0.0;//upper right
									
}

 //this is used to translate the plane along the Y axis
void Plane::translateY(float amount){
	
	vertex[1]= vertex[1]+amount; //lower left y
	vertex[5]= vertex[5]+amount;//lower right y
	vertex[9]= vertex[9]+amount;//upper left
	vertex[13]= vertex[13]+amount;//upper left
	vertex[17]= vertex[17]+amount; //lower right
	vertex[21]= vertex[21]+amount; //upper right
	
	
}

