
//#define BENCHMARK  //define to run for 100 frames and then output time stats
#define USE_SCISSORS //define to use scissor rects; undefine to get maximum power usage / GPU usage
//#define USE_PROFILER

#ifndef _LINUX
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <assert.h>
#include <string.h>
#include <math.h>
#include <windows.h>
//#include <tchar.h> //Win32 only

#ifdef USE_PROFILER
#include <profiler.h>
#endif

#else

#include <stdio.h>
#include <assert.h>
#include <string.h>
#include <fcntl.h> 
#include <malloc.h> 
#include <math.h> 
#include <stdlib.h>

#endif


#define UNREF(X) ((void)(X))

#include <VG/openvg.h>
#include <VG/vgu.h>
#include <EGL/egl.h>
#include <FSL/fslutil.h>

#ifdef FSL_EGL_USE_X11
#include <X11/X.h>
#include <X11/Xlib.h>
#include <unistd.h>
#endif
typedef int HGint32;
typedef unsigned int HGuint32;

typedef short HGint16;
typedef unsigned short HGuint16;

typedef signed char HGint8;
typedef unsigned char HGuint8;

typedef int HGbool;

#define HG_FALSE (0 == 1)
#define HG_TRUE (1 == 1)

#define OVG_RGB(r,g,b) ((b<<8)|(g<<16)|(r<<24))

typedef struct
{
    const float*   floats;
	const HGuint8* cmds;
	HGint32        nCommands;
	HGint32		   nFloats;
	HGuint32       color;
	float		   transform[9];
} PathData;



#include "slider1.h"
#include "slider2.h"
#include "slider_selector.h"
#include "fsl_logo.h"
#include "speaker.h"

#define NUM_PATHS_SLIDER1  (sizeof(slider1_paths)/sizeof(PathData))
#define NUM_PATHS_SLIDER2  (sizeof(slider2_paths)/sizeof(PathData))
#define NUM_PATHS_SLIDER_SELECTOR  (sizeof(slider_selector_paths)/sizeof(PathData))
#define NUM_PATHS_FSL_LOGO (sizeof(fsl_logo_paths)/sizeof(PathData))
#define NUM_PATHS_SPEAKER	(sizeof(speaker_paths)/sizeof(PathData))


#ifdef FSL_EGL_USE_X11
typedef struct XWindow_s {
	Display *display;
	Window window;
	int screen;
	Visual *visual;
	GC gc;
	Colormap colormap;
	int depth;
	int pixelsize;
	XFontStruct *font_info;
	XWindowAttributes attr;
	Picture picture;
	Pixmap pixmap;
} XWindow;
#else
typedef int XWindow;
#endif
#define PRINT_FRAMERATE 1


const float slider1MinX = 0.0f;
const float slider1MaxX = 800.0f;
const float slider1MinY = 0.0f;
const float slider1MaxY = 480.0f;
/*
int					currentFrame = 0;
EGLDisplay			egldisplay;
EGLConfig			eglconfig;
EGLSurface			eglsurface;
EGLContext			eglcontext;
*/

#ifdef BENCHMARK

//#pragma warning(disable:4115)	/* named type definition in parentheses (this comes from a visual studio include file) */

int g_nProcCount = 0;
int g_MsgCount = -1;
_LARGE_INTEGER g_Freq;
TCHAR g_pszProcMsg[2048][200];
_LARGE_INTEGER g_lnProcTime[2048];
int g_procTypes[2048];


void OutPutMsg()
{
	if(g_MsgCount < 0)
		return;
	TCHAR szBuf[256];
	double procTime = 0;
	int procType = 1;
	for(int i = 0; i < g_MsgCount; i++)
	{
		procType = g_procTypes[i];
		procTime = ((double)(g_lnProcTime[i].QuadPart) / g_Freq.QuadPart) * 1000;
		if(procType > 1)
		{
			#ifdef UNDER_CE
				_snwprintf 
			#else
				_stprintf_s
			#endif
					(szBuf, 256, _T("%s end\t%f\r\n"), g_pszProcMsg[i], procTime);
		}
		else if(procType > 0)
		{
			#ifdef UNDER_CE
				_snwprintf 
			#else
				_stprintf_s
			#endif
					(szBuf, 256, _T("%s start\t%f\r\n"), g_pszProcMsg[i], procTime);
		}
		else
		{
			#ifdef UNDER_CE
				_snwprintf 
			#else
				_stprintf_s
			#endif
					(szBuf, 256, _T("%s\t%f\r\n"), g_pszProcMsg[i], procTime);
		}
		OutputDebugString(szBuf);
	}
	g_MsgCount = -1;
}
#endif

#ifdef BENCHMARK
void PutMessage(int procType, TCHAR msg[200])
{

	_LARGE_INTEGER lnTime;
	// ProcEnd
	if(procType > 1)
	{
		QueryPerformanceCounter(&lnTime);
	}

	if(g_MsgCount >= 2047)
	{
		OutPutMsg();
	}
	if(g_MsgCount < 0)
	{
		g_MsgCount = 0;
		ZeroMemory(g_pszProcMsg, sizeof(2048 * 200 * sizeof(TCHAR)));
	}
	
	memcpy(g_pszProcMsg[g_MsgCount], msg, 200 * sizeof(TCHAR));
	g_procTypes[g_MsgCount] = procType;

	if(procType < 2)
	{
		QueryPerformanceCounter(&lnTime);
	}
	g_lnProcTime[g_MsgCount] = lnTime;
	g_MsgCount++;

}
#else
#define PutMessage(x,y)
#endif
/*--------------------------------------------------------------*/

int					renderWidth = 0;
int					renderHeight = 0;

EGLDisplay		g_egldisplay;
EGLConfig		g_eglconfig;
EGLSurface		g_eglsurface;
EGLContext		g_eglcontext;

unsigned int	g_currentFrame = 0;

VGPath path;
VGPaint pnt;

VGPath  g_paths_speaker[NUM_PATHS_SPEAKER];
VGPaint g_paint_speaker[NUM_PATHS_SPEAKER];

void createSpeaker()
{
	int i;
	
	for(i=0;i< (int)NUM_PATHS_SPEAKER;i++)
	{
		g_paths_speaker[i] = vgCreatePath(VG_PATH_FORMAT_STANDARD,VG_PATH_DATATYPE_F,1.0f, 0.0f, 0, 0, VG_PATH_CAPABILITY_ALL);
        vgAppendPathData(g_paths_speaker[i], speaker_paths[i].nCommands,(VGubyte*)speaker_paths[i].cmds,speaker_paths[i].floats);
		g_paint_speaker[i] = vgCreatePaint();
		vgSetColor(g_paint_speaker[i], speaker_paths[i].color | 255);
	}

	return;
}

void renderSpeaker()
{
	int i;

	vgSeti(VG_FILL_RULE, VG_NON_ZERO);
	vgSeti(VG_MATRIX_MODE, VG_MATRIX_PATH_USER_TO_SURFACE);

	for(i = 0; i < (int)NUM_PATHS_SPEAKER; i++)
	{
		vgSetPaint(g_paint_speaker[i], VG_FILL_PATH);		
		vgDrawPath(g_paths_speaker[i], VG_FILL_PATH);
	}

	return;
}


VGPath  g_paths_slider_selector[NUM_PATHS_SLIDER_SELECTOR];
VGPaint g_paint_slider_selector;

void createSliderSelector()
{
		int i;
		g_paint_slider_selector = vgCreatePaint();

		for(i=0;i<(int)NUM_PATHS_SLIDER_SELECTOR;i++)
		{
			g_paths_slider_selector[i] = vgCreatePath(VG_PATH_FORMAT_STANDARD,VG_PATH_DATATYPE_F,1.0f, 0.0f, 0, 0, VG_PATH_CAPABILITY_ALL);

            vgAppendPathData(g_paths_slider_selector[i], slider_selector_paths[i].nCommands,(VGubyte*)slider_selector_paths[i].cmds,slider_selector_paths[i].floats);
		}

	
		g_paint_slider_selector = vgCreatePaint();

		vgSetParameteri(g_paint_slider_selector, VG_PAINT_TYPE, VG_PAINT_TYPE_LINEAR_GRADIENT);
		
		float afLinearGradientPoints[4] = {	-0.25f, 0, 0.72f, 0	};

		vgSetParameterfv(g_paint_slider_selector, VG_PAINT_LINEAR_GRADIENT, 4, afLinearGradientPoints);
		
		vgSetParameteri(g_paint_slider_selector, VG_PAINT_COLOR_RAMP_SPREAD_MODE, VG_COLOR_RAMP_SPREAD_REFLECT);

	return;
}

void renderSliderSelector()
{
	int i;

	vgSetPaint(g_paint_slider_selector, VG_FILL_PATH);
	vgSeti(VG_FILL_RULE, VG_NON_ZERO);
	vgSeti(VG_MATRIX_MODE, VG_MATRIX_PATH_USER_TO_SURFACE);

	vgSetPaint(g_paint_slider_selector, VG_FILL_PATH);

	for(i = 0; i < (int)NUM_PATHS_SLIDER_SELECTOR; i++)
	{
		vgDrawPath(g_paths_slider_selector[i], VG_FILL_PATH);
	}

	return;
}

VGPath  g_paths_slider1[NUM_PATHS_SLIDER1];
VGPath  g_paths_slider2[NUM_PATHS_SLIDER2];
VGPaint g_paint_slider1;
VGPaint g_paint_slider2;


void createSlider()
{
		int i;
		g_paint_slider1 = vgCreatePaint();

		for(i=0;i<(int)NUM_PATHS_SLIDER1;i++)
		{
			g_paths_slider1[i] = vgCreatePath(VG_PATH_FORMAT_STANDARD,VG_PATH_DATATYPE_F,1.0f, 0.0f, 0, 0, VG_PATH_CAPABILITY_ALL);

            vgAppendPathData(g_paths_slider1[i], slider1_paths[i].nCommands,(VGubyte*)slider1_paths[i].cmds,slider1_paths[i].floats);
		}

        for(i=0;i<(int)NUM_PATHS_SLIDER2;i++)
		{
			g_paths_slider2[i] = vgCreatePath(VG_PATH_FORMAT_STANDARD,VG_PATH_DATATYPE_F,1.0f, 0.0f, 0, 0, VG_PATH_CAPABILITY_ALL);

            vgAppendPathData(g_paths_slider2[i], slider2_paths[i].nCommands,(VGubyte*)slider2_paths[i].cmds,slider2_paths[i].floats);
		}
	
		g_paint_slider2 = vgCreatePaint();

		vgSetParameteri(g_paint_slider2, VG_PAINT_TYPE, VG_PAINT_TYPE_LINEAR_GRADIENT);
		
		float afLinearGradientPoints[4] = {	0, 5, 0, 10	};

		vgSetParameterfv(g_paint_slider2, VG_PAINT_LINEAR_GRADIENT, 4, afLinearGradientPoints);
		
		vgSetParameteri(g_paint_slider2, VG_PAINT_COLOR_RAMP_SPREAD_MODE, VG_COLOR_RAMP_SPREAD_REFLECT);

	return;
}

void renderSlider( HGuint32 color)
{
	int i;

	vgSetPaint(g_paint_slider1, VG_FILL_PATH);
	vgSeti(VG_FILL_RULE, VG_NON_ZERO);
	vgSeti(VG_MATRIX_MODE, VG_MATRIX_PATH_USER_TO_SURFACE);

	for(i = 0; i < (int)NUM_PATHS_SLIDER1; i++)
	{
		vgSetColor(g_paint_slider1, color | 255);
		vgDrawPath(g_paths_slider1[i], VG_FILL_PATH);
	}

	vgSetPaint(g_paint_slider2, VG_FILL_PATH);

	for(i = 0; i < (int)NUM_PATHS_SLIDER2; i++)
	{
		vgDrawPath(g_paths_slider2[i], VG_FILL_PATH);
	}

	return;
}

VGImage g_backgroundMask;
VGPath	g_backgroundPath;
VGPaint g_backgroundPaint;

void createBackground()
{
	{
		int i,y,x;

		g_backgroundMask = vgCreateMaskLayer(800,480);
		vgMask( g_backgroundMask, VG_CLEAR_MASK, 0, 0, 800, 480);
		
		for( y = 0; y < 480; y += 8)
		{
			vgFillMaskLayer(g_backgroundMask, 0, y, 800, 2, 0.0);
		}
		
		for( x = 0; x < 800; x += 8)
		{
			vgFillMaskLayer(g_backgroundMask, x, 0, 2, 480, 0.0);
		}
		
		vgMask( g_backgroundMask, VG_SET_MASK, 0, 0, 800, 480);


		VGPath  paths_fsl_logo[NUM_PATHS_FSL_LOGO];

		vgSeti(VG_FILL_RULE, VG_NON_ZERO);

        for(i = 0; i < NUM_PATHS_FSL_LOGO; i++)
		{
			paths_fsl_logo[i] = vgCreatePath(VG_PATH_FORMAT_STANDARD,VG_PATH_DATATYPE_F,1.0f, 0.0f, 0, 0, VG_PATH_CAPABILITY_ALL);

            vgAppendPathData(paths_fsl_logo[i], fsl_logo_paths[i].nCommands,(VGubyte*)fsl_logo_paths[i].cmds,fsl_logo_paths[i].floats);
		}

		for(i = 0; i < (NUM_PATHS_FSL_LOGO); i++)
		{
			vgSeti(VG_MATRIX_MODE, VG_MATRIX_PATH_USER_TO_SURFACE);
			vgLoadIdentity();
			vgTranslate(400,240);
			vgScale(8.0f, 8.0f);
			vgTranslate(-32,-32);
			vgMultMatrix(fsl_logo_paths[i].transform);
			vgRenderToMask(paths_fsl_logo[i], VG_FILL_PATH, VG_UNION_MASK);
		}

		vgCopyMask(g_backgroundMask,0,0,0,0,800,480);
	}

	g_backgroundPaint = vgCreatePaint();
	vgSetParameteri(g_backgroundPaint, VG_PAINT_TYPE, VG_PAINT_TYPE_LINEAR_GRADIENT);
	
	float afLinearGradientPoints[4] = { 0,0,400,400 };

	vgSetParameterfv(g_backgroundPaint, VG_PAINT_LINEAR_GRADIENT, 4, afLinearGradientPoints);

	vgSetParameteri(g_backgroundPaint, VG_PAINT_COLOR_RAMP_SPREAD_MODE, VG_COLOR_RAMP_SPREAD_REFLECT);

	float afColourRampStops[] = {
		0.0f, 0.13f, 0.13f, 0.13f, 1.0f,
		1.0f, 0.38f, 0.38f, 0.38f, 1.0f,
	};

	//vgSetParameterfv(g_backgroundPaint, VG_PAINT_COLOR_RAMP_STOPS, 10, afColourRampStops);

	g_backgroundPath = vgCreatePath(
		VG_PATH_FORMAT_STANDARD, 
		VG_PATH_DATATYPE_F, 
		1.0f, 0.0f, 
		40,
		100,
		VG_PATH_CAPABILITY_APPEND_TO);
	vguRect(g_backgroundPath, 0, 0, 800, 480);
	vgRemovePathCapabilities(g_backgroundPath, VG_PATH_CAPABILITY_APPEND_TO);
	
	return;
}

void renderBackground()
{
	vgLoadIdentity();
	vgMask( g_backgroundMask, VG_SET_MASK, 0, 0, 800, 480);
	vgSeti(VG_MASKING, VG_TRUE);
	vgSetPaint(g_backgroundPaint, VG_FILL_PATH);
	vgDrawPath(g_backgroundPath,  VG_FILL_PATH);
	vgSeti(VG_MASKING, VG_FALSE);
	return;
}

void createIcon1()
{
	return;
}

void renderIcon1()
{
	return;
}


#define NUM_SRECTS 6

void renderSimple(VGboolean bScissoring)
{
	int i;
	PutMessage(1, TEXT("Drawing"));
	vgSeti(VG_SCISSORING, bScissoring);

	static float slider_position[5] = {5.0f,200.0f,300.0f,250.0f,340.0f};
	static float slider_modifier[5] = {-1.0f,1.0f,-1.0f,1.0f,-1.0f};
	static HGuint32 slider_color[5] = {	OVG_RGB(0xFF, 0x00, 0x00),
										OVG_RGB(0x00, 0xFF, 0x00),
										OVG_RGB(0x00, 0x00, 0xFF),
										OVG_RGB(0x00, 0x00, 0x00),
										OVG_RGB(0xFF, 0xFF, 0x00)};
	static int current_speaker = 0;
	static float zoom = 2.0f;
	static float zoom_modifier = 0.1f;

	VGint scissor_coord[4*NUM_SRECTS];

	//modify pos & modifiers
	for(i = 0; i < 5; i++)
	{
		slider_position[i] += slider_modifier[i];
		if((slider_position[i] > 350) || (slider_position[i] < 0))
			slider_modifier[i] *= -1.0f;
	}

	for(i = 0; i < 5; i++)
	{
		scissor_coord[((i+1)*4)+0]= (VGint)(slider_position[i] + 203);
		scissor_coord[((i+1)*4)+1]= (VGint)(75 + (i * 75));
		scissor_coord[((i+1)*4)+2]=38;
		scissor_coord[((i+1)*4)+3]=40;

//		vgTranslate(400.0f + slider_position[i],100.0f + i * 75.0f);
//		vgScale(7.0f, 4.0f);
//		vgTranslate(-32,-32); 
	}

	zoom += zoom_modifier;
	if(zoom > 2.5f)
	{
		zoom = 2.5f;
		zoom_modifier *= -1.0f;
	}
	else if(zoom < 1.9)
	{
		zoom = 2.0;
		zoom_modifier *= -1.0f;
		current_speaker++;
		if(current_speaker > 3)
			current_speaker = 0;
	}

	switch(current_speaker)
	{
		case 0:
			scissor_coord[0]=20.0;
			scissor_coord[1]=20.0;
			scissor_coord[2]=150.0;
			scissor_coord[3]=150.0;
			break;
		case 1:
			scissor_coord[0]=620.0;
			scissor_coord[1]=20.0;
			scissor_coord[2]=150.0;
			scissor_coord[3]=150.0;
			break;
		case 2:
			scissor_coord[0]=620.0;
			scissor_coord[1]=320.0;
			scissor_coord[2]=150.0;
			scissor_coord[3]=150.0;
			break;
		case 3:
			scissor_coord[0]=20.0;
			scissor_coord[1]=320.0;
			scissor_coord[2]=150.0;
			scissor_coord[3]=150.0;
			break;
	}
	vgSetiv(VG_SCISSOR_RECTS, 4 * NUM_SRECTS, scissor_coord);
	//vgSetiv(VG_SCISSOR_RECTS, 8, scissor_coord);

	float clearColor[4] = {0,0,0,0};
	vgSetfv(VG_CLEAR_COLOR, 4, clearColor);
	vgClear(0, 0, 800, 480);

	renderBackground();

	for(i = 0; i < 5; i++)
	{
		vgLoadIdentity();
		vgTranslate(400.0f,100.0f + i * 75.0f);
		vgScale(7.0f, 4.0f);
		vgTranslate(-32,-32); 
		renderSlider(slider_color[i]);
	}

	for(i = 0; i < 5; i++)
	{
		vgLoadIdentity();
		vgTranslate(400.0f + slider_position[i],100.0f + i * 75.0f);
		vgScale(7.0f, 4.0f);
		vgTranslate(-32,-32); 
		renderSliderSelector();
	}

/*
	vgLoadIdentity();
	vgScale(7.0f, 4.0f);
	vgTranslate(25.0f,-8.7f);

	for(int i = 0; i < 5; i++)
	{
		renderSlider(slider_color[i]);
		vgTranslate(slider_position[i],0.0f);
		renderSliderSelector();
		vgTranslate((slider_position[i] * -1.0f),17.0f);
	}
*/
	vgLoadIdentity();
	vgTranslate(100, 100); // third
	if(current_speaker == 0)
		vgScale(zoom,zoom);
	else
		vgScale(2.0f,2.0f); // second
	vgTranslate(-32,-32); //first
	renderSpeaker();

	vgLoadIdentity();
	vgTranslate(700,100);
	if(current_speaker == 1)
		vgScale(zoom,zoom);
	else
		vgScale(2.0f,2.0f);
	vgTranslate(-32,-32); 
	renderSpeaker();

	vgLoadIdentity();
	vgTranslate(700,400);
	if(current_speaker == 2)
		vgScale(zoom,zoom);
	else
		vgScale(2.0f,2.0f);
	vgTranslate(-32,-32); 
	renderSpeaker();

	vgLoadIdentity();
	vgTranslate(100, 400);
	if(current_speaker == 3)
		vgScale(zoom,zoom);
	else
		vgScale(2.0f,2.0f);
	vgTranslate(-32,-32); 
	renderSpeaker();


/*
		vgDestroyPaint(paint);

		for(i = 0; i < NUM_PATHS_SLIDER1; i++)
			vgDestroyPath(paths_slider1[i]);

		for(i = 0; i < NUM_PATHS_SLIDER2; i++)
			vgDestroyPath(paths_slider2[i]);
    }
*/

#ifdef BENCHMARK
	PutMessage(1, TEXT("vgFinish"));
	vgFinish();
	PutMessage(2, TEXT("vgFinish"));
#endif

}

void render(int w, int h)
{
	vgLoadIdentity();

	renderSimple(VG_FALSE);
	assert(vgGetError() == VG_NO_ERROR);

	renderWidth = w;
	renderHeight = h;
	
	PutMessage(1, TEXT("eglSwapBuffers"));
	eglSwapBuffers(g_egldisplay, g_eglsurface);
	assert(eglGetError() == EGL_SUCCESS);
	PutMessage(2, TEXT("eglSwapBuffers"));
}

//--------------------------------------------------------------------------------------
// Name: initEGL()
// Desc: Initialize the X window and EGL objects / state need draw to screen
//--------------------------------------------------------------------------------------

fslBool initEGL(XWindow* xwin)
{
	static const EGLint configAttribs16[] =
	{
			EGL_RED_SIZE,           5,
			EGL_GREEN_SIZE,         6,
			EGL_BLUE_SIZE,          5,
			EGL_ALPHA_SIZE,         0,
			EGL_DEPTH_SIZE,			16,
			EGL_SAMPLES,            0,
			EGL_NONE
	};
	EGLint	numconfigs 	= 0;
	
#ifdef FSL_EGL_USE_X11
	static const EGLint configAttribs24[] =
	{
			EGL_RED_SIZE,           8,
			EGL_GREEN_SIZE,         8,
			EGL_BLUE_SIZE,          8,
			EGL_ALPHA_SIZE,         0,
			EGL_DEPTH_SIZE,			16,			
			EGL_SAMPLES,            0,
			EGL_NONE
	};


	unsigned int	width		= 500;
	unsigned int	height		= 350;

	unsigned int 	dummy, depth;
	int 		x;
	Window 		rootwindow;

	printf("+Starting Main Window X Initialization:\n");

	printf("\tXOpenDisplay [");
	xwin->display = XOpenDisplay(NULL);
	printf("%d]\n", (int)xwin->display);
	assert(xwin->display != NULL);

	printf("\tDefaultScreen [");
	xwin->screen = DefaultScreen(xwin->display);
	printf("%d]\n", xwin->screen);

	rootwindow = RootWindow(xwin->display,xwin->screen);

	printf("\tXCreateSimpleWindow \n");
	xwin->window = XCreateSimpleWindow(xwin->display, rootwindow, 0, 0, width, height, 0, 0, WhitePixel (xwin->display, xwin->screen));
	
	XMapWindow(xwin->display, xwin->window);
	
	XStoreName(xwin->display,xwin->window,"Freescale HMI VG Demo");

	{
		XSizeHints Hints;
		Hints.flags=PSize|PMinSize|PMaxSize;
		Hints.min_width=Hints.max_width=Hints.base_width=width;
		Hints.min_height=Hints.max_height=Hints.base_height=height;
		XSetWMNormalHints(xwin->display,xwin->window,&Hints);
	}	
	
	if(!XGetGeometry(xwin->display, xwin->window, &rootwindow, &x, &x, &width, &height, &dummy, &depth) || (depth == 0))
	{
		printf("\tERROR: X11 Window Creation Error\n");
		return FSL_FALSE;
	}
	
	printf("-Finished Main Window X Initialization:\n");
	
	printf("+Starting EGL Initialization:\n");

	//Initialize EGL
	printf("\teglGetDisplay \n");
	g_egldisplay = eglGetDisplay ( xwin->display );
	fslEGLCheck(FSL_TRUE);

	printf("\teglInitialize \n");
	eglInitialize(g_egldisplay, NULL, NULL);
	fslEGLCheck(FSL_TRUE);

	printf("\teglBindAPI \n");
	eglBindAPI(EGL_OPENVG_API);
	
	printf("\teglChooseConfig \n");
	if(depth == 16)
		eglChooseConfig(g_egldisplay, configAttribs16, &g_eglconfig, 1, &numconfigs);
	else if(depth == 24)
		eglChooseConfig(g_egldisplay, configAttribs24, &g_eglconfig, 1, &numconfigs);
	else
	{
		printf("\tERROR: Only 16b and 24b windows supported \n");
		return FSL_FALSE;
	}
	
	fslEGLCheck(FSL_TRUE);

	if(numconfigs != 1)
	{
		printf("\tERROR: No EGL suitable configurations found. \n");
		return FSL_FALSE;
	}

	printf("\teglCreateWindowSurface \n");
	g_eglsurface = eglCreateWindowSurface(g_egldisplay, g_eglconfig, xwin->window, NULL);
	fslEGLCheck(FSL_TRUE);
	
#else 
	g_egldisplay = eglGetDisplay(EGL_DEFAULT_DISPLAY);

    printf("*eglInitialize \n");
	eglInitialize(g_egldisplay, NULL, NULL);
	fslEGLCheck(FSL_TRUE);

	printf("\teglBindAPI \n");
	eglBindAPI(EGL_OPENVG_API);

	
	printf("*eglChooseConfig \n");
	eglChooseConfig(g_egldisplay, configAttribs16, &g_eglconfig, 1, &numconfigs);
	fslEGLCheck(FSL_TRUE);
	if(numconfigs != 1)
	{
		printf("\tERROR: No EGL suitable configurations found. \n");
		return FSL_FALSE;
	}

	printf("*eglCreateWindowSurface \n");
	g_eglsurface = eglCreateWindowSurface(g_egldisplay, g_eglconfig, open("/dev/fb0", O_RDWR), NULL);
	fslEGLCheck(FSL_TRUE);	
#endif


	printf("\tglCreateContext \n");
	g_eglcontext = eglCreateContext(g_egldisplay, g_eglconfig, NULL, NULL);
	fslEGLCheck(FSL_TRUE);

	printf("\teglMakeCurrent \n");
	eglMakeCurrent(g_egldisplay, g_eglsurface, g_eglsurface, g_eglcontext);
	fslEGLCheck(FSL_TRUE);
	
	printf("-Finished EGL Initialization:\n");
	
	return FSL_TRUE;
}

//--------------------------------------------------------------------------------------
// Name: cleanupEGL
// Desc: Cleanup any objects created in initEGL
//--------------------------------------------------------------------------------------

void cleanupEGL(XWindow* xwin)
{
	printf("Cleaning Up EGL and Main Window\n");
	eglMakeCurrent(g_egldisplay, EGL_NO_SURFACE, EGL_NO_SURFACE, EGL_NO_CONTEXT);
	eglTerminate(g_egldisplay);
#ifdef FSL_EGL_USE_X11	
    	XCloseDisplay(xwin->display);
#endif	
	eglReleaseThread();
}

fslBool initVG()
{
	
	createBackground();
	createSlider();
	createSliderSelector();
	createSpeaker();
	return FSL_TRUE;
}

fslBool cleanupVG()
{
	vgDestroyPaint(pnt);
	vgDestroyPath(path);
	return FSL_TRUE;
}

//--------------------------------------------------------------------------------------
// Name: main
// Desc: main
//--------------------------------------------------------------------------------------
int main (void)
{
	XWindow	xMainWindow;
	EGLint 	width = 0, height = 0;
	
#ifdef PRINT_FRAMERATE	
	unsigned int	startTime = 0, endTime = 0;
#endif	

	
	printf("Freescale VG HMI Demo\n");
	printf("++Starting Initialization\n");
	
	//Set up error handler here
	
	assert( initEGL( &xMainWindow ) );

	assert( initVG() );
	
	eglQuerySurface(g_egldisplay, g_eglsurface, EGL_WIDTH, &width);
	eglQuerySurface(g_egldisplay, g_eglsurface, EGL_HEIGHT, &height);
	printf("--Finished Initializing (%d x %d).  Now Rendering. \n",width, height);

	while (g_currentFrame < 1000)
	{
		eglQuerySurface(g_egldisplay, g_eglsurface, EGL_WIDTH, &width);
		eglQuerySurface(g_egldisplay, g_eglsurface, EGL_HEIGHT, &height);


		render(width, height);

		g_currentFrame++;

#ifdef PRINT_FRAMERATE
		// Printing FPS metric
		if(g_currentFrame % 100 == 0)
		{
			endTime = fslGetTickCount();
			if(startTime && startTime < endTime)
			{
				
				printf("\t%f FPS, %f ms/frame [%d] (%d x %d)\n", 
					100 * 1000.f / (endTime - startTime),  
					(float)(endTime - startTime)/(float)100, 
					g_currentFrame, width, height);
			
			}
			startTime = fslGetTickCount();
		}
#endif		
							
	}
	cleanupVG( );
	cleanupEGL( &xMainWindow );

	return 0;
}


